Sub NullEditor(Control&,PropertyName$)
    'Do nothing
End Sub

ReDim PropertyEditors(1) As Integer
Bind PropertyEditors(0) To NullEditor

Type TStringsEditor Extends QForm
     Public:
     Control       As Integer
     Class         As String
     Private:
     MenuEdit      as QPopupMenu
     se_Copy       As QMenuItem
     se_Paste      As QMenuItem
     n1            As QMenuItem
     se_Load       As QMenuItem
     se_Save       As QMenuItem
     StringsEditor As QForm
     LabelLines    As QLabel
     RichEdit      As QRichEdit
     ButtonOk      As QButton
     ButtonCancel  As QButton
     OpenDialog    As QOpenDialog
     SaveDialog    As QSaveDialog

    With This

    Private:
    
    Function GetClassName(hWnd&) As String
        DefStr s = Space$(255)
        DefInt L = GetClassName(hWnd&,s,255)
        Result = Left$(s,L)
    End Function

    Sub EditorShow(Sender As QForm )
        DefStr s
        DefInt Count,L,i
        .Class = .GetClassName(.Control)
        .RichEdit.Clear
        Select Case .Class
        Case "QListBox","ListBox"
             Count = SendMessageA(.Control,LB_GETCOUNT,0,0)
             For i = 0 To Count -1
                 L = SendMessageA(.Control,LB_GETTEXTLEN,I,0)
                 s = Space$(L)
                 SendMessageA(.Control,LB_GETTEXT,I,VarPTR(s))
                 .RichEdit.AddStrings s
             Next i
        Case "QComboBox","ComboBox"
             Count = SendMessageA(.Control,CB_GETCOUNT,0,0)
             For i = 0 To Count -1
                 L = SendMessageA(.Control,CB_GETLBTEXTLEN,I,0)
                 s = Space$(L)
                 SendMessageA(.Control,CB_GETLBTEXT,I,VarPTR(s))
                 .RichEdit.AddStrings s
             Next i
        End Select
        .LabelLines.Caption = Format$("Lines : %d",.RichEdit.LineCount)
        SetFocus .RichEdit.Handle
    End Sub

    Sub RichEditChange(Sender As QRichEdit)
        .LabelLines.Caption = Format$("Lines : %d",.RichEdit.LineCount)
    End Sub

    Sub se_CopyClick(Sender As QMenuItem)
        SendMessage(.RichEdit.Handle,WM_COPY,0,0)
    End Sub

    Sub se_PasteClick(Sender As QMenuItem)
        SendMessage(.RichEdit.Handle,WM_PASTE,0,0)
    End Sub

    Sub se_LoadClick(Sender As QMenuItem)
        If .OpenDialog.Execute Then
           .RichEdit.LoadFromFile .OpenDialog.FileName
        End If
    End Sub

    Sub se_SaveClick(Sender As QMenuItem)
        DefStr File
        If .SaveDialog.Execute Then
           File = .SaveDialog.FileName
           Select Case .SaveDialog.FilterIndex
           Case 1 : File = ChangeFileExt(File,".txt")
           Case 2 : File = ChangeFileExt(File,"")
           End Select
           .RichEdit.SaveToFile File
        End If
    End Sub

    Public:

    Sub CallEditor(Control As Integer,PropertyName As String)
        DefInt i
        DefStr s
        Dim v As Variant
        Dim Buff As QStringList
        .Control = Control
        If .ShowModal = mrOk Then
           Buff.Text = .RichEdit.Text
           Buff.Text = ReplaceSubStr$(Buff.Text,Chr$(0),Chr$(13) & Chr$(10))
           Select Case .Class
           Case "QListBox","ListBox"
                SendMessageA(.Control,LB_RESETCONTENT,0,0)
                For i = 0 To .RichEdit.LineCount -1
                    s = Buff.Item(i)
                    SendMessageA(.Control,LB_ADDSTRING,0,VarPTR(s))
                Next i
           Case "QComboBox","ComboBox"
                SendMessageA(.Control,CB_RESETCONTENT,0,0)
                For i = 0 To .RichEdit.LineCount -1
                    s = Buff.Item(i)
                    SendMessageA(.Control,CB_ADDSTRING,0,VarPTR(s))
                Next i
           End Select
           v = .RichEdit.Text
           SetPropValue .Control,PropertyName,v
        End If
    End Sub

    End With

    Constructor
    SaveDialog.Filter = "Text file|*.txt|All files|*.*"
    OpenDialog.Filter = "Text file|*.txt|All files|*.*"
    se_Copy.Caption  = "&Copy"
    se_Copy.OnClick  = This.se_CopyClick
    se_Paste.Caption = "&Paste"
    se_Paste.OnClick = This.se_PasteClick
    n1.Caption       = "-"
    se_Load.Caption  = "Load..."
    se_Load.OnClick  = This.se_LoadClick
    se_Save.Caption  = "&Save..."
    se_Save.OnClick  = This.se_SaveClick
    MenuEdit.AddItems This.se_Copy,This.se_Paste,This.n1,This.se_Load,This.se_Save
    Caption      = "Strings Editor"
    Width       = 378
    Height      = 308
    BorderStyle = 3
    Font.Name   = "Tahoma"
    Font.Color  = -2147483640
    Font.Size   = 8
    OnShow      = This.EditorShow
    Center
    LabelLines.Parent  = This
    LabelLines.Top     = 4
    LabelLines.Left    = 4
    LabelLines.Width   = 44
    LabelLines.Caption = "Lines :"
    LabelLines.Color   = &HD8E9EC
    RichEdit.Parent  = This
    RichEdit.Top     = 20
    RichEdit.Left    = 4
    RichEdit.Width   = 361
    RichEdit.Height  = 217
    RichEdit.Color   = &HFFFFFF
    RichEdit.PlainText = True
    RichEdit.PopupMenu = This.MenuEdit
    RichEdit.OnChange  = This.RichEditChange
    ButtonOk.Parent      = This
    ButtonOk.Top         = 244
    ButtonOk.Left        = 288
    ButtonOk.Caption     = "&Ok"
    ButtonOk.ModalResult = 1
    ButtonCancel.Parent      = This
    ButtonCancel.Top         = 244
    ButtonCancel.Left        = 208
    ButtonCancel.Caption     = "&Cancel"
    ButtonCancel.ModalResult = 2
    End Constructor
End Type

Dim StringsEditor As TStringsEditor

ReDim PropertyEditors(UBound(PropertyEditors) +1) As Integer
Bind PropertyEditors(UBound(PropertyEditors) -1) To StringsEditor.CallEditor

Type TFontEditor Extends QFontDialog
     Public:
     Control       As Integer
     Class         As String
     With This
     
     Public:

     Sub CallEditor(Control As Integer,PropertyName As String)
        DefInt FontPtr
        DefStr s
        Dim LF   As LOGFONT
        Dim v    As Variant
        Dim F    As TFont
        Dim Font As QFont
        .Control = Control
        FontPtr = GetPropValue(Control,PropertyName)
        If FontPtr Then
           MemCpy F,FontPtr,SizeOf(F)
           Font.Name    = StrFromPtr(F.Name)-Chr$(0)
           Font.Size    = F.Size
           Font.Color   = F.Color
           Font.Charset = F.Charset
           If F.Bold      Then Font.AddStyles fsBold
           If F.Italic    Then Font.AddStyles fsItalic
           If F.Underline Then Font.AddStyles fsUnderline
           If F.Strikeout Then Font.AddStyles fsStrikeout
        End If
        .GetFont(Font)
        If .Execute Then
           .SetFont(Font)
           GetObject(Font.Handle,SizeOf(LF),LF)
           F.Name      = NewZStr(Font.Name)
           F.Size      = Font.Size
           F.Bold      = IIf(LF.lfWeight = 700,1,0)
           F.Italic    = LF.lfItalic
           F.Underline = LF.lfUnderline
           F.Strikeout = LF.lfStrikeout
           F.CharSet   = LF.lfCharset
           F.Color     = Font.Color
           If F.Handle Then DeleteObject F.Handle
           F.Handle = Font.Handle
           If FontPtr Then
              MemCpy FontPtr,F,SizeOf(F)
              v = FontPtr
              SetPropValue .Control,PropertyName,v
              SendMessage .Control,WM_SETFONT,F.Handle,1
           End If
        End If
    End Sub
    
    End With
End Type

Dim FontEditor As TFontEditor

ReDim PropertyEditors(UBound(PropertyEditors) +1) As Integer
Bind PropertyEditors(UBound(PropertyEditors) -1) To FontEditor.CallEditor

Type TColorEditor Extends QObject
     Private:
     CC         As CHOOSECOLOR
     Hook       As Integer
     R          As Rect
     Public:
     Caption    As String
     Color      As Long
     Colors(16) As Long
     Style      As Long
     Control    As Integer

     With This

      Function HookProc(hWnd As Long,Msg As Long,wParam As Long,lParam As Long) As Long
          If Msg = WM_INITDIALOG Then
             GetWindowRect(hWnd,.R)
             MoveWindow(hWnd,((Screen.Width -(.R.Right -.R.Left)))/2,((Screen.Height-(.R.Bottom -.R.Top) ))/2,(.R.Right -.R.Left),(.R.Bottom -.R.Top),0)
             If Len(.Caption) Then
                SetWindowText(hWnd,.Caption)
             End If
             Result = True
          Else
             Result = False
          End If
      End Function

      Function Execute() As Long
          DefInt i
          .CC.hWndOwner   = Application.Handle
          .CC.RGBResult   = .Color
          .CC.Flags       = CC_RGBINIT OR CC_ENABLEHOOK
          MemCpy This.CC.lpCustColors,VarPtr(This.Colors(0)),SizeOf(Integer)*16
          Select Case .Style
          Case 1
              .CC.Flags = .CC.Flags OR CC_FULLOPEN
          Case 2
              .CC.Flags = .CC.Flags OR CC_PREVENTFULLOPEN
          End Select
          .CC.lpfnHook = .Hook
          If ChooseColorDlg(.CC) <> 0 then
             MemCpy VarPtr(This.Colors(0)),This.CC.lpCustColors,SizeOf(Integer)*16
             .Color = .CC.RGBResult
             Result = True
          Else
             Result = False
          End If
      End Function

      Sub CallEditor(Control As Integer,PropertyName As String)
           Dim V As Variant
           DefInt Brush,i
           .Control = Control
           .Color = GetPropValue(.Control,PropertyName)
           If .Execute Then
              V = .Color
              SetPropValue(.Control,PropertyName,v)
              InvalidateRect .Control,0,1
           End If
      End Sub

      Sub Initialize
          DefInt F4,i
          Bind F4 To This.HookProc
          .Hook = SetNewCallBack_4(F4)
          .CC.lStructSize  = SizeOf(This.CC)
          .CC.lpCustColors = NewIntArray(16)
      End Sub

    End With

    Constructor
        Caption = "Choose Color..."
        Colors(1)  = &H0
        Colors(2)  = &H808080
        Colors(3)  = &H000080
        Colors(4)  = &H008080
        Colors(5)  = &H008000
        Colors(6)  = &H808000
        Colors(7)  = &H800000
        Colors(8)  = &H800080
        Colors(9)  = &HFFFFFF
        Colors(10) = &HC0C0C0
        Colors(11) = &H0000FF
        Colors(12) = &H00FFFF
        Colors(13) = &H00FF00
        Colors(14) = &HFFFF00
        Colors(15) = &HFF0000
        Colors(16) = &HFF00FF
        Initialize
    End Constructor
End Type

Dim ColorEditor As TColorEditor

ReDim PropertyEditors(UBound(PropertyEditors) +1) As Integer
Bind PropertyEditors(UBound(PropertyEditors) -1) To ColorEditor.CallEditor


Function GetClassPropertyEditor(hWnd&,PropName$) As Integer
        DefInt i,k
        Dim Class As TClass
        Dim List  As TList
        Dim Prop  As TProperty
        DefStr s = Space$(255),ClassName$
        DefInt L = GetClassName(hWnd&,s,255)
        ClassName$ = Left$(s,L)
        Result = -1
        For i = 0 To UBound(ClassList)-1
            MemCpy Class,ClassList(i),SizeOf(Class)
            s = StrFromPtr(Class.ClassName)-Chr$(0)
            If UCase$(s) = UCase$(ClassName$) Then
               MemCpy List,Class.PropList,SizeOf(List)
               ReDim Properties(List.Count) As Integer
               MemCpy VarPTR(Properties(0)),List.Items,SizeOf(Integer)*List.Count
               For k = 0 To List.Count -1
                   MemCpy Prop,Properties(k),SizeOf(Prop)
                   s = StrFromPtr(Prop.Name)-Chr$(0)
                   If UCase$(s) = UCase$(PropName$) Then
                      Result = Prop.Editor
                      Exit For
                   End If
               Next k
            End If
        Next i
End Function

Sub RegisterPropertyEditor(ClassName$,PropertyName$,Editor&)
    DefInt i,k,PList,Properties()
    DefStr s,Cn
    Dim L As TList
    Dim P As TProperty
    Dim C As TClass
    If ClassName$ <> "" Then
        For i = 0 To UBound(ClassList) -1
            MemCpy C,ClassList(i),SizeOf(C)
            Cn = StrFromPtr(C.ClassName)-Chr$(0)
            PList = C.PropList
            If UCase$(Cn) = UCase$(ClassName$) Then
               If PList Then
                  MemCpy L,PList,SizeOf(L)
                  ReDim Properties(L.Count) As Integer
                  If L.Items Then
                     MemCpy VarPTR(Properties(0)),L.Items,SizeOf(Integer)*L.Count
                     For k = 0 To L.Count -1
                         MemCpy P,Properties(k),SizeOf(P)
                         Cn = StrFromPtr(P.Name) -Chr$(0)
                         If UCase$(Cn) = UCase$(PropertyName$) Then
                            P.Editor = Editor&
                            MemCpy Properties(k),P,SizeOf(P)
                            MemCpy L.Items,VarPTR(Properties(0)),SizeOf(Integer)*L.Count
                            MemCpy PList,L,SizeOf(L)
                            Exit For
                         End If
                     Next k
                  End If
               End If
            End If
        Next i
    Else
        For i = 0 To UBound(ClassList) -1
            MemCpy C,ClassList(i),SizeOf(C)
            Cn = StrFromPtr(C.ClassName)-Chr$(0)
            PList = C.PropList
            If PList Then
               MemCpy L,PList,SizeOf(L)
               ReDim Properties(L.Count) As Integer
               If L.Items Then
                  MemCpy VarPTR(Properties(0)),L.Items,SizeOf(Integer)*L.Count
                  For k = 0 To L.Count -1
                     MemCpy P,Properties(k),SizeOf(P)
                     Cn = StrFromPtr(P.Name) -Chr$(0)
                     If UCase$(Cn) = UCase$(PropertyName$) Then
                        P.Editor = Editor&
                        MemCpy Properties(k),P,SizeOf(P)
                        MemCpy L.Items,VarPTR(Properties(0)),SizeOf(Integer)*L.Count
                        MemCpy PList,L,SizeOf(L)
                        Exit For
                      End If
                  Next k
               End If
            End If
        Next i
    End If
End Sub
