Const HH_DISPLAY_TOPIC       = &H0
Const HH_SET_WIN_TYPE        = &H4
Const HH_GET_WIN_TYPE        = &H5
Const HH_GET_WIN_HANDLE      = &H6
Const HH_DISPLAY_TEXT_POPUP  = &HE   ' Display string resource ID or text in a pop-up window.
Const HH_HELP_CONTEXT        = &HF   ' Display mapped numeric value in  dwData.
Const HH_TP_HELP_CONTEXTMENU = &H10  ' Text pop-up help, similar to WinHelp's HELP_CONTEXTMENU.
Const HH_TP_HELP_WM_HELP     = &H11  ' text pop-up help, similar to WinHelp's HELP_WM_HELP.
Const HH_CLOSE_ALL           = &H12
Declare Function HtmlHelp Lib "hhctrl.ocx" Alias "HtmlHelpA" (ByVal hwndCaller As Long,ByVal pszFile As String, ByVal uCommand As Long, ByVal dwData As Long) As Long

Declare Sub HH_DoError
Type QHTMLHelp extends QObject
    Private:
    Error as long
    Public:
    Parent       as long
    FileName     as string property Set SetFileName
    HelpCommand  as long property   Set SetHelpCommand
    Topic        as string property Set SetTopic
    OnError      as Event(HH_DoError)
    With This

    Property Set SetFileName(File as string)
    If File <> .FileName then
       .FileName = File
    End If
    End Property

    Property Set SetHelpCommand(Command as long)
    If Command <> .HelpCommand then
       .HelpCommand = Command
    End If
    End Property
    
    Function Execute() as integer
    .Error = HTMLHelp( .Parent,.FileName,.HelpCommand, 0 )
    If .Error = 0 then
       If .OnError <> 0 then
          CallFunc .OnError
          GoTo Exit_Function
          Result = 0
       End If
    End If
    Result = 1
    Exit_Function:
    End Function
    
    Property Set SetTopic(Tp as string)
    If Tp <> .Topic then
       .Topic = Tp
       If .HelpCommand = HH_DISPLAY_TOPIC then
          .FileName = .FileName & "::/" & .Topic
          .Execute()
       End If
    End If
    End Property

    End With

    Constructor
    HelpCommand = HH_DISPLAY_TOPIC
    End Constructor
End Type

