Type SHFILEINFO
    hIcon         As Long         '  out: icon
    iIcon         As Integer      '  out: icon index
    dwAttributes  As DWord        '  out: SFGAO_ flags
    szDisplayName As String * 260 '  out: display name (or path)
    szTypeName    As String * 80  '  out: type name
End Type


Const SHGFI_DISPLAYNAME    = &H200
Const SHGFI_TYPENAME       = &H400
Const SHGFI_SYSICONINDEX   = &H4000
Const SHGFI_LARGEICON      = &H0
Const SHGFI_SMALLICON      = &H1
Const SHGFI_ICON           = &H100

Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (pszPath As String,dwFileAttributes As Long,psfi As SHFILEINFO,cbFileInfo As Long,uFlags As Long) As Dword
Declare Function DestroyIcon Lib "user32" Alias "DestroyIcon" (ByVal hIcon As Long) As Long
Declare Sub DoItemClick
Type QMacroList extends QScrollBox
    Private:
    MemList       as QStringList
    LibList       as QStringList
    FI            as SHFILEINFO
    Public :
    Canvas        as QCanvas
    ItemHeight    as integer
    ItemCount     as integer
    ActiveItem    as integer
    ActiveCaption as string
    TextColor     as integer
    Mask          as string Property Set SetMask
    Macro         as string Property Set SetMacro
    OnItemClick   as Event(DoItemClick)
    
    Private:
    Function GetFormatDir(Directory as string) as string
    If RInstr(Directory,"\") = Len(Directory) then
       Result = Directory
       else
       Result = Directory + "\"
    End If
    End Function
    
    Function ExtCount(Extension as string) as integer
    Dim Count as integer,Flag as integer
    Flag = 0
    Count=0
    While Flag = 0
          Count++
          If Field$(Extension,";",Count) = "" then Flag = 1
    WEnd
    Result = Count -1
    End Function
    
    Sub LoadFiles(Mask as string)
    Dim File as string, i as integer
    This.LibList.Clear
    File = Dir$(This.GetFormatDir(This.Macro) + Mask,0)
    If File <> "" then
       This.LibList.AddItems File
       If instr(File, ".", 0) > 0 then
          SHGetFileInfo(This.GetFormatDir(This.Macro) + File,0,This.FI,SizeOf(This.FI),SHGFI_DISPLAYNAME Or SHGFI_TYPENAME or SHGFI_ICON)
          DestroyIcon This.FI.hIcon
       End if
       While File <> ""
             File = Dir$
             If File <> "" then
                This.LibList.AddItems File
                If instr(File, "." ,0) > 0 then
                   SHGetFileInfo(This.GetFormatDir(This.Macro) + File,0,This.FI,SizeOf(This.FI),SHGFI_DISPLAYNAME Or SHGFI_TYPENAME or SHGFI_ICON)
                   DestroyIcon This.FI.hIcon
                End If
             End If
        WEnd
    End If
    End Sub

    Sub Load
    Dim Count as integer,i as integer,Mask as string
    Count = This.ExtCount(This.Mask)
    If Count > 0 then
       For i = 1 to Count
           Mask = Field$(This.Mask,";",i)
           This.LoadFiles(Mask)
       Next i
    Else
      This.LoadFiles(This.Mask)
    End If
    End Sub
    
    Public:

    Sub Initialize
       With This
            .Canvas.Parent = This
            .VertIncrement = .ItemHeight
            Select Case .BorderStyle
                   Case 0 : .Canvas.Width = .Width -2
                            .Canvas.Height = .Height -2
                   Case 1 : .Canvas.Width = .Width -4
                            .Canvas.Height = .Height -4
                   End Select
       End With
    End Sub
    
    Sub Update
    Dim i as integer,Top as integer,s as string
    Dim TW as integer, TH as integer,Caption as string
       With This
            TH = .Canvas.TextHeight("Wg")
            .ItemCount = .MemList.ItemCount
            .Canvas.Height = (.ItemHeight * .ItemCount) +1
            If .Height < .Canvas.Height then
               .Canvas.Width = .Width -22 'scrollbar width
               Else
               .Canvas.Width = .Width - 4* .BorderStyle 'border width
            End If
            For i = 0 to .MemList.ItemCount -1
                s = .MemList.Item(i)
                Top     = val(Field$(s,"*",1))
                Caption = Field$(s,"*",2)
                TW = .Canvas.TextWidth(Caption)
                If .ActiveItem = i then
                   .Canvas.Line(0,Top,.Canvas.Width,Top,-2147483627)
                   .Canvas.Line(1,Top+1,.Canvas.Width,Top+1,-2147483627)
                   .Canvas.Line(0,Top,0,Top + .ItemHeight,-2147483627)
                   .Canvas.Line(1,Top+1,1,(Top + .ItemHeight),-2147483627)
                   .Canvas.Line(0,(Top+ .ItemHeight)-1,.Width,(Top + .ItemHeight)-1,&HFFFFFF)
                   .Canvas.TextOut((.Canvas.Width - TW)\2 +1,(Top + (.ItemHeight - TH)\2)+1,Caption,.TextColor,-1)
                   Else
                   .Canvas.Line(0,Top,.Canvas.Width,Top,-2147483637)
                   .Canvas.TextOut((.Canvas.Width - TW)\2,(Top + (.ItemHeight - TH)\2),Caption,.TextColor,-1)
                End If
            Next i
            .Canvas.Line(0,.Canvas.Height -1,.Canvas.Width,.Canvas.Height -1,-2147483637)
       End With
    End Sub
    
    Sub LoadMacro(LList as QStringList)
    Dim i as integer, s as string, Line as string
        With This
             .MemList.Clear
             .ActiveItem = -1
             .ActiveCaption = ""
             For i = 0 to LList.ItemCount -1
                 s = LList.Item(i)
                 Line = Format$("%d*%s",i * .ItemHeight,LList.Item(i) - (.Mask - "*"))
                 .MemList.AddItems Line
             Next i
             .Canvas.Repaint
        End With
    End Sub
    
    Event Canvas.OnMouseDown(Button as integer,X as integer,Y as integer,Shift as integer)
    Dim i as integer,s as string,Top as integer
        With This
             For i = 0 to .MemList.ItemCount -1
                s = .MemList.Item(i)
                Top = val(Field$(s,"*",1))
                If Y > Top and Y < Top + .ItemHeight then
                   .ActiveItem = i
                   .ActiveCaption = Field$(s,"*",2)
                   .Canvas.Repaint
                   If .OnItemClick <> 0 then CallFunc .OnItemClick
                   Exit For
                End If
             Next i
        End With
    End Event
    
    Event Canvas.OnPaint
         With This
              .Update
         End With
    End Event
    
    Property Set SetMacro(value as string)
        With This
             If value <> .Macro then
                If DirExists(value) then
                   .Macro = value
                   .Load
                   .LoadMacro(This.LibList)
                   .Canvas.Repaint
                End If
             End If
        End With
    End Property

    Property Set SetMask(value as string)
        With This
             If value <> .Mask then
               .Mask = value
               .Load
               .LoadMacro(This.LibList)
               .Canvas.Repaint
             End If
        End With
    End Property
    
    Constructor
    Mask = "*.emc"
    Height = 200
    ActiveItem = -1
    ActiveCaption = ""
    ItemHeight = 28
    Initialize
    End Constructor
End Type
