'
' --------------------------------------------------------------------
' QREDEX OBJECT           January 2001             By Jacques Philippe
'
' EXTENDS  QRICHEDIT   with   COPY , CUT , PASTE , DELETE , SELECT ALL
'
' COMPONENT CODE
' --------------------------------------------------------------------
'
Type QREDEX Extends QRichEdit
    With QREDEX
        PRIVATE:
        myPopMenu As QPopUpMenu
        mnuCut AS QMenuItem
        mnuCopy AS QMenuItem
        mnuPaste AS QMenuItem
        mnuDelete AS QMenuItem
        mnuSelectAll As QMenuItem
'
'       ON POP UP
'       ---------
        Sub OnPopUp_mnuCutPast
            DefInt boolSelLength, boolReadOnly, boolLenClip
            If .selLength Then boolSelLength = 1
            If .readOnly Then
                boolReadOnly = 0
            Else
                boolReadOnly = 1
            End If
            ClipBoard.Open
                If Len(ClipBoard.Text) Then boolLenClip = 1
            ClipBoard.Close
            .mnuCut.Visible = boolSelLength And boolReadOnly And boolLenClip
            .mnuPaste.Visible = boolReadOnly And boolLenClip
            .mnuDelete.Visible = boolSelLength And boolReadOnly
            .mnuCopy.Visible = boolSelLength
            .mnuSelectAll.Visible = 1 ' True
        End Sub
'
'       mnu CUT
'       -------
        Sub OnClic_mnuCut
            DefStr txt, selectStart, selectEnd
            ClipBoard.Open
                ClipBoard.Text = .SelText
            ClipBoard.Close
            txt = .Text
            selectStart = Left$(txt, .SelStart)
            selectEnd = Right$(txt, Len(Txt) - .SelStart - .selLength)
            .Text = selectStart & selectEnd
        End Sub
'
'       mnu PASTE
'       ---------
        Sub OnClic_mnuPaste
            DefStr txt, selectStart, selectEnd, past
            ClipBoard.Open
                past = ClipBoard.Text
            ClipBoard.Close
            txt = .Text
            selectStart = Left$(txt, .SelStart)
            selectEnd = Right$(txt, Len(Txt) - .SelStart)
            .Text = selectStart + past + selectEnd
        End Sub
'
'       mnu COPY
'       --------
        Sub OnClic_mnuCopy
            ClipBoard.Open
                ClipBoard.Text = .SelText
            ClipBoard.Close
        End Sub
'
'       mnu DELETE
'       ----------
        Sub OnClic_mnuDelete
            DefStr txt, selectStart, selectEnd
            txt = .Text
            selectStart = Left$(txt, .SelStart)
            selectEnd = Right$(txt, Len(Txt) - .SelStart - .selLength)
            .Text = selectStart & selectEnd
        End Sub
'
'       mnu SELECTALL
'       -------------
        Sub OnClic_mnuSelectAll
            .SelStart = 0
            .selLength = Len(.Text)
        End Sub
'
        constRUCTOR
            PopUpMenu = QREDEX.myPopMenu
            myPopMenu.OnPopUp = QREDEX.OnPopUp_mnuCutPast
            mnuCut.Caption = "&Cut"
            mnuCut.OnClick = QREDEX.OnClic_mnuCut
            mnuCopy.Caption = "C&opy"
            mnuCopy.OnClick = QREDEX.OnClic_mnuCopy
            mnuPaste.Caption = "&Paste"
            mnuPaste.OnClick = QREDEX.OnClic_mnuPaste
            mnuDelete.Caption = "&Delete"
            mnuDelete.OnClick = QREDEX.OnClic_mnuDelete
            mnuSelectAll.Caption = "&Select All"
            mnuSelectAll.OnClick = QREDEX.OnClic_mnuSelectAll
            myPopMenu.AddItems QREDEX.mnuCopy, QREDEX.mnuCut, QREDEX.mnuDelete, _
                                                            QREDEX.mnuPaste, QREDEX.mnuSelectAll
        END constRUCTOR
    End With
End Type
' --------------------------------------------------------------------
'
  