'''QSuperEdit fast highlight syntax edit control for Rapidq
'''Version 1.0
'''coded by Nastase Eodor - 2008
'''dll control version 8.0.101

'''Editor Comments Style
Const SE_ANSISTYLE                = 0
Const SE_PASCALSTYLE              = 1
Const SE_CSTYLE                   = 2
Const SE_ASMSTYLE                 = 3
Const SE_BASICSTYLE               = 4
Const SE_VBSTYLE                  = 5

'''Editor Options
Const SEO_ALTSETSCOLUMNMODE       = 0  'HOLDING DOWN THE ALT KEY WILL PUT THE SELECTION MODE INTO COLUMNAR FORMAT
Const SEO_AUTOINDENT              = 1  'WILL INDENT THE CARET ON NEW LINES WITH THE SAME AMOUNT OF LEADING WHITE SPACE AS THE PRECEDING LINE
Const SEO_AUTOSIZEMAXSCROLLWIDTH  = 2  'AUTOMATICALLY RESIZES THE MAXSCROLLWIDTH PROPERTY WHEN INSERTING TEXT
Const SEO_DISABLESCROLLARROWS     = 3  'DISABLES THE SCROLL BAR ARROW BUTTONS WHEN YOU CAN'T SCROLL IN THAT DIRECTION ANY MORE
Const SEO_DRAGDROPEDITING         = 4  'ALLOWS YOU TO SELECT A BLOCK OF TEXT AND DRAG IT WITHIN THE DOCUMENT TO ANOTHER LOCATION
Const SEO_DROPFILES               = 5  'ALLOWS THE EDITOR ACCEPT OLE FILE DROPS
Const SEO_ENHANCEHOMEKEY          = 6  'ENHANCES HOME KEY POSITIONING, SIMILAR TO VISUAL STUDIO
Const SEO_ENHACEENDKEY            = 7  'enhances End key positioning, similar to JDeveloper
Const SEO_GROUPUNDO               = 8  'WHEN UNDOING/REDOING ACTIONS, HANDLE ALL CONTINOUS CHANGES OF THE SAME KIND IN ONE CALL INSTEAD UNDOING/REDOING EACH COMMAND SEPARATELY
Const SEO_HALFPAGESCROLL          = 9  'WHEN SCROLLING WITH PAGE-UP AND PAGE-DOWN COMMANDS, ONLY SCROLL A HALF PAGE AT A TIME
Const SEO_HIDESHOWSCROLLBARS      = 10  'IF ENABLED, THEN THE SCROLLBARS WILL ONLY SHOW WHEN NECESSARY.  IF YOU HAVE SCROLLPASTEOL, THEN IT THE HORIZONTAL BAR WILL ALWAYS BE THERE (IT USES MAXLENGTH INSTEAD)
Const SEO_KEEPCARETX              = 11 'WHEN MOVING THROUGH LINES W/O CURSOR PAST EOL, KEEPS THE X POSITION OF THE CURSOR
Const SEO_NOCARET                 = 12 'MAKES IT SO THE CARET IS NEVER VISIBLE
Const SEO_NOSELECTION             = 13 'DISABLES SELECTING TEXT
Const SEO_RIGHTMOUSEMOVESCURSOR   = 14 'WHEN CLICKING WITH THE RIGHT MOUSE FOR A POPUP MENU, MOVE THE CURSOR TO THAT LOCATION
Const SEO_SCROLLBYONELESS         = 15 'FORCES SCROLLING TO BE ONE LESS
Const SEO_SCROLLHINTFOLLOWS       = 16 'THE SCROLL HINT FOLLOWS THE MOUSE WHEN SCROLLING VERTICALLY
Const SEO_SCROLLPASTEOF           = 17 'ALLOWS THE CURSOR TO GO PAST THE END OF FILE MARKER
Const SEO_SCROLLPASTEOL           = 18 'ALLOWS THE CURSOR TO GO PAST THE LAST CHARACTER INTO THE WHITE SPACE AT THE END OF A LINE
Const SEO_SHOWSCROLLHINT          = 19 'SHOWS A HINT OF THE VISIBLE LINE NUMBERS WHEN SCROLLING VERTICALLY
Const SEO_SHOWSPECIALCHARS        = 20 'SHOWS THE SPECIAL CHARACTERS
Const SEO_SMARTTABDELETE          = 21 'SIMILAR TO SMART TABS, BUT WHEN YOU DELETE CHARACTERS
Const SEO_SMARTTABS               = 22 'WHEN TABBING, THE CURSOR WILL GO TO THE NEXT NON-WHITE SPACE CHARACTER OF THE PREVIOUS LINE
Const SEO_SPECIALLINEDEFAULTFG    = 23 'DISABLES THE FOREGROUND TEXT COLOR OVERRIDE WHEN USING THE ONSPECIALLINECOLOR EVENT
Const SEO_TABINDENT               = 24 'WHEN ACTIVE <TAB> AND <SHIFT><TAB> ACT AS BLOCK INDENT, UNINDENT WHEN TEXT IS SELECTED
Const SEO_TABSTOSPACES            = 25 'CONVERTS A TAB CHARACTER TO A SPECIFIED NUMBER OF SPACE CHARACTERS
Const SEO_TRIMTRAILINGSPACES      = 26 'SPACES AT THE END OF LINES WILL BE TRIMMED AND NOT SAVED

'''Editor Messages
Const SEM_ADDLINE                 = 40000
Const SEM_DELLINE                 = 40001
Const SEM_INSERTLINE              = 40004
Const SEM_INDEXOF                 = 40005
Const SEM_EXCHANGE                = 40006
Const SEM_CLEAR                   = 40007
Const SEM_LINECOUNT               = 40134
Const SEM_LOADFROMFILE            = 40008
Const SEM_SAVETOFILE              = 40009
Const SEM_PRINT                   = 40010
Const SEM_EXPORTHTML              = 40011
Const SEM_EXPORTRTF               = 40012
Const SEM_ADDBOOKMARKBMP          = 40013
Const SEM_ADDBOOKMARKRESOURCE     = 40133
Const SEM_SETBOOKMARK             = 40014
Const SEM_DELBOOKMARK             = 40015
Const SEM_INVALIDATE              = 40100
Const SEM_INVALIDATEGUTTER        = 40101
Const SEM_REPAINT                 = 40102
Const SEM_UPDATE                  = 40103
Const SEM_SHOWGUTTER              = 40147
Const SEM_SHOWLINENUMBERS         = 40148
Const SEM_SETCOMPLETIONINFO       = 40151
Const SEM_GETCOMPLETIONINFO       = 40152
Const SEM_SETTEXTITEMLISTCOMPL    = 40153
Const SEM_SETTEXTINSERTLISTCOMPL  = 40154
Const SEM_ALLOWCOMPLETION         = 40155

Const SEM_SETBOUNDS               = 40016
Const SEM_GETBOUNDS               = 40017
Const SEM_SETTEXT                 = 40018
Const SEM_GETTEXT                 = 40019
Const SEM_SETSELTEXT              = 40149
Const SEM_GETSELTEXT              = 40150
Const SEM_SETSELSTART             = 40157
Const SEM_GETSELSTART             = 40158
Const SEM_SETSELLENGTH            = 40159
Const SEM_GETSELLENGTH            = 40160
Const SEM_SETLINETEXT             = 40020
Const SEM_GETLINETEXT             = 40021
Const SEM_SETCARETXY              = 40022
Const SEM_GETCARETXY              = 40023
Const SEM_SETBKCOLOR              = 40024
Const SEM_GETBKCOLOR              = 40025
Const SEM_SETACTIVELINECOLOR      = 40026
Const SEM_GETACTIVELINECOLOR      = 40027
Const SEM_SETSPECIALLINEINFO      = 40028
Const SEM_GETSPECIALLINEINFO      = 40144
Const SEM_SETTOPLINE              = 40029
Const SEM_GETTOPLINE              = 40030
Const SEM_SETGUTTERWIDTH          = 40031
Const SEM_GETGUTTERWIDTH          = 40032
Const SEM_SETGUTTERCOLOR          = 40033
Const SEM_GETGUTTERCOLOR          = 40034
Const SEM_SETFONTNAME             = 40035
Const SEM_GETFONTNAME             = 40036
Const SEM_SETFONTSIZE             = 40037
Const SEM_GETFONTSIZE             = 40038
Const SEM_SETSELECTIONMODE        = 40039
Const SEM_GETSELECTIONMODE        = 40040
Const SEM_SETSELECTIONCOLOR       = 40041
Const SEM_GETSELECTIONCOLOR       = 40042
Const SEM_SETWANTTABS             = 40043
Const SEM_GETWANTTABS             = 40044
Const SEM_SETWANTRETURNS          = 40045
Const SEM_GETWANTRETURNS          = 40046
Const SEM_SETWORDWRAP             = 40047
Const SEM_GETWORDWRAP             = 40048
Const SEM_SETWORDWRAPBMP          = 40049
Const SEM_GETWORDWRAPBMP          = 40050
Const SEM_SETREADONLY             = 40051
Const SEM_GETREADONLY             = 40052
Const SEM_SETINSERTCARET          = 40053
Const SEM_GETINSERTCARET          = 40054
Const SEM_SETOVERWRITECARET       = 40144
Const SEM_GETOVERWRITECARET       = 40145
Const SEM_SETRIGHTEDGE            = 40055
Const SEM_GETRIGHTEDGE            = 40056
Const SEM_SETRIGHTEDGECOLOR       = 40057
Const SEM_GETRIGHTEDGECOLOR       = 40058
Const SEM_SETOPTIONS              = 40059
Const SEM_GETOPTIONS              = 40060
Const SEM_SETKEYWORDS             = 40061
Const SEM_GETKEYWORDS             = 40062
Const SEM_SETKEYSATTRIBUTES       = 40063
Const SEM_GETKEYSATTRIBUTES       = 40064
Const SEM_SETSTRINGATTRIBUTES     = 40065
Const SEM_GETSTRINGATTRIBUTES     = 40066
Const SEM_SETSYMBOLATTRIBUTES     = 40067
Const SEM_GETSYMBOLATTRIBUTES     = 40068
Const SEM_SETCOMMENTATTRIBUTES    = 40069
Const SEM_GETCOMMENTATTRIBUTES    = 40070
Const SEM_SETDOTATTRIBUTES        = 40071
Const SEM_GETDOTATTRIBUTES        = 40072
Const SEM_SETNUMBERATTRIBUTES     = 40073
Const SEM_GETNUMBERATTRIBUTES     = 40074
Const SEM_SETIDENTIFIERATTRIBUTES = 40075
Const SEM_GETIDENTIFIERATTRIBUTES = 40076
Const SEM_SETIDENTIFIERCHAR       = 40077
Const SEM_GETIDENTIFIERCHAR       = 40078
Const SEM_SETDOLARVARIBLES        = 40079
Const SEM_GETDOLARVARIBLES        = 40080
Const SEM_SETDOTACTIVE            = 40081
Const SEM_GETDOTACTIVE            = 40082
Const SEM_SETDOUBLEQUOTES         = 40083
Const SEM_GETDOUBLEQUOTES         = 40084
Const SEM_SETERRORLINE            = 40085
Const SEM_GETERRORLINE            = 40086
Const SEM_SETBREAKLINE            = 40087
Const SEM_GETBREAKLINE            = 40088
Const SEM_GETERRORLINECOLOR       = 40089
Const SEM_GETBREAKLINECOLOR       = 40090
Const SEM_LOADATTRIBUTESFROMINI   = 40097
Const SEM_SAVEATTRIBUTESTOINI     = 40107
Const SEM_SETCOMMENTSTYLE         = 40098
Const SEM_GETCOMMENTSTYLE         = 40099
Const SEM_ADDKEYWORD              = 40108
Const SEM_DELETEKEYWORD           = 40109
Const SEM_SETMAXUNDO              = 40110
Const SEM_GETMAXUNDO              = 40111
Const SEM_SETHIDESELECTION        = 40112
Const SEM_GETHIDESELECTION        = 40113
Const SEM_SETTABSTOP              = 40114
Const SEM_GETTABSTOP              = 40115
Const SEM_SETTABWIDTH             = 40116
Const SEM_GETTABWIDTH             = 40117
Const SEM_SETSCROLLBARS           = 40118
Const SEM_GETSCROLLBARS           = 40119
Const SEM_SETSCROLLHINTCOLOR      = 40120
Const SEM_GETSCROLLHINTCOLOR      = 40121
Const SEM_SETSCROLLHINTFORMAT     = 40122
Const SEM_GETSCROLLHINTFORMAT     = 40123
Const SEM_SETHINT                 = 40124
Const SEM_GETHINT                 = 40125
Const SEM_SETSHOWHINT             = 40126
Const SEM_GETSHOWHINT             = 40127
Const SEM_GETINSERTMODE           = 40165
Const SEM_SETINSERTMODE           = 40166
Const SEM_FINDSTRING              = 40130
Const SEM_REPLACESTRING           = 40131
Const SEM_GETPATHNAME             = 40132
Const SEM_REDO                    = 40135
Const SEM_UNDO                    = 40136
Const SEM_PASTE                   = 40137
Const SEM_CUT                     = 40138
Const SEM_COPY                    = 40139
Const SEM_SELECTALL               = 40140
Const SEM_CANREDO                 = 40141
Const SEM_CANUNDO                 = 40142
Const SEM_CANPASTE                = 40143
Const SEM_SETGUTTER               = 40167
Const SEM_GETGUTTER               = 40168
Const SEM_DETECTPREPROCESSOR      = 40169
Const SEM_SETPOPUPMENU            = 40172
Const SEM_GETKEYSTROKES           = 40170
Const SEM_SETKEYSTROKES           = 40171
Const SEM_ADDKEYSTROKE            = 40173
Const SEM_DELKEYSTROKE            = 40174

'''Editor Notyfications
Const SEN_CLICK                   = 40091
Const SEN_DBLCLICK                = 40092
Const SEN_GUTTERCLICK             = 40093
Const SEN_CHANGE                  = 40094
Const SEN_SCROLL                  = 40095
Const SEN_MOUSECURSOR             = 40096
Const SEN_GUTTERPAINT             = 40104
Const SEN_PAINT                   = 40105
Const SEN_STATUSCHANGE            = 40106
Const SEN_ENTER                   = 40128
Const SEN_EXIT                    = 40129
Const SEN_KEYPRESS                = 40156
Const SEN_DROPFILES               = 40175


'''Editor keystrokes commands
Const ecNone             =    0 ' Nothing. Useful for user event to handle command
Const ecViewCommandFirst =    0
Const ecViewCommandLast  =  500
Const ecEditCommandFirst =  501
Const ecEditCommandLast  = 1000
Const ecLeft            = 1    ' Move cursor left one char
Const ecRight           = 2    ' Move cursor right one char
Const ecUp              = 3    ' Move cursor up one line
Const ecDown            = 4    ' Move cursor down one line
Const ecWordLeft        = 5    ' Move cursor left one word
Const ecWordRight       = 6    ' Move cursor right one word
Const ecLineStart       = 7    ' Move cursor to beginning of line
Const ecLineEnd         = 8    ' Move cursor to end of line
Const ecPageUp          = 9    ' Move cursor up one page
Const ecPageDown        = 10   ' Move cursor down one page
Const ecPageLeft        = 11   ' Move cursor right one page
Const ecPageRight       = 12   ' Move cursor left one page
Const ecPageTop         = 13   ' Move cursor to top of page
Const ecPageBottom      = 14   ' Move cursor to bottom of page
Const ecEditorTop       = 15   ' Move cursor to absolute beginning
Const ecEditorBottom    = 16   ' Move cursor to absolute end
Const ecGotoXY          = 17   ' Move cursor to specific coordinates, Data = PPoint
Const ecSelection       = 100  ' Add this to ecXXX command to get equivalent command, but with selection enabled. This is not a command itself.
Const ecSelLeft         = ecLeft + ecSelection  ' Same as commands above, except they affect selection, too
Const ecSelRight        = ecRight + ecSelection
Const ecSelUp           = ecUp + ecSelection
Const ecSelDown         = ecDown + ecSelection
Const ecSelWordLeft     = ecWordLeft + ecSelection
Const ecSelWordRight    = ecWordRight + ecSelection
Const ecSelLineStart    = ecLineStart + ecSelection
Const ecSelLineEnd      = ecLineEnd + ecSelection
Const ecSelPageUp       = ecPageUp + ecSelection
Const ecSelPageDown     = ecPageDown + ecSelection
Const ecSelPageLeft     = ecPageLeft + ecSelection
Const ecSelPageRight    = ecPageRight + ecSelection
Const ecSelPageTop      = ecPageTop + ecSelection
Const ecSelPageBottom   = ecPageBottom + ecSelection
Const ecSelEditorTop    = ecEditorTop + ecSelection
Const ecSelEditorBottom = ecEditorBottom + ecSelection
Const ecSelGotoXY       = ecGotoXY + ecSelection  ' Data = PPoint
Const ecSelWord         = 198
Const ecSelectAll       = 199  ' Select entire contents of editor, cursor to end
Const ecCopy            = 201  ' Copy selection to clipboard
Const ecScrollUp        = 211  ' Scroll up one line leaving cursor position unchanged.
Const ecScrollDown      = 212  ' Scroll down one line leaving cursor position unchanged.
Const ecScrollLeft      = 213  ' Scroll left one char leaving cursor position unchanged.
Const ecScrollRight     = 214  ' Scroll right one char leaving cursor position unchanged.
Const ecInsertMode      = 221  ' Set insert mode
Const ecOverwriteMode   = 222  ' Set overwrite mode
Const ecToggleMode      = 223  ' Toggle ins/ovr mode
Const ecNormalSelect    = 231  ' Normal selection mode
Const ecColumnSelect    = 232  ' Column selection mode
Const ecLineSelect      = 233  ' Line selection mode
Const ecMatchBracket    = 250  ' Go to matching bracket
Const ecCommentBlock    = 251  ' Comment Block
Const ecGotoMarker0     = 301  ' Goto marker
Const ecGotoMarker1     = 302  ' Goto marker
Const ecGotoMarker2     = 303  ' Goto marker
Const ecGotoMarker3     = 304  ' Goto marker
Const ecGotoMarker4     = 305  ' Goto marker
Const ecGotoMarker5     = 306  ' Goto marker
Const ecGotoMarker6     = 307  ' Goto marker
Const ecGotoMarker7     = 308  ' Goto marker
Const ecGotoMarker8     = 309  ' Goto marker
Const ecGotoMarker9     = 310  ' Goto marker
Const ecSetMarker0      = 351  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker1      = 352  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker2      = 353  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker3      = 354  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker4      = 355  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker5      = 356  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker6      = 357  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker7      = 358  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker8      = 359  ' Set marker, Data = PPoint - X, Y Pos
Const ecSetMarker9      = 360  ' Set marker, Data = PPoint - X, Y Pos
Const ecGotFocus        = 480
Const ecLostFocus       = 481
Const ecContextHelp     = 490  ' Help on Word, Data = Word
Const ecDeleteLastChar  = 501  ' Delete last char (i.e. backspace key)
Const ecDeleteChar      = 502  ' Delete char at cursor (i.e. delete key)
Const ecDeleteWord      = 503  ' Delete from cursor to end of word
Const ecDeleteLastWord  = 504  ' Delete from cursor to start of word
Const ecDeleteBOL       = 505  ' Delete from cursor to beginning of line
Const ecDeleteEOL       = 506  ' Delete from cursor to end of line
Const ecDeleteLine      = 507  ' Delete current line
Const ecClearAll        = 508  ' Delete everything
Const ecLineBreak       = 509  ' Break line at current position, move caret to new line
Const ecInsertLine      = 510  ' Break line at current position, leave caret
Const ecChar            = 511  ' Insert a character at current position
Const ecImeStr          = 550  ' Insert character(s) from IME
Const ecUndo            = 601  ' Perform undo if available
Const ecRedo            = 602  ' Perform redo if available
Const ecCut             = 603  ' Cut selection to clipboard
Const ecPaste           = 604  ' Paste clipboard to current position
Const ecBlockIndent     = 610  ' Indent selection
Const ecBlockUnindent   = 611  ' Unindent selection
Const ecTab             = 612  ' Tab key
Const ecShiftTab        = 613  ' Shift+Tab key
Const ecAutoCompletion  = 650
'Const ecUpperCase       = 620 ' apply to the current or previous word
'Const ecLowerCase       = 621
Const ecToggleCase      = 622
Const ecTitleCase       = 623
Const ecUpperCaseBlock  = 625 ' apply to current selection, or current char if no selection
Const ecLowerCaseBlock  = 626
Const ecToggleCaseBlock = 627
Const ecString          = 630  'Insert a whole string
Const ecUserFirst       = 1001 ' Start of user-defined commands

type T_PRINTINFO
       Title      As Long
       Header     As Long
       Footer     As Long
       FontFace   As Long
       FontSize   As Long
       PrintColor As Long
end type

type T_ATTRIBUTES
       Background As Long
       Foreground As Long
       Bold       As Long
       Italic     As Long
       Underline  As Long
       Strikeout  As Long
end type

type T_SEARCHREPLACE
       FindString    As Long
       ReplaceString As Long
       MatchCase     As Long
       WholeWord     As Long
       Backwards     As Long
       EntireScope   As Long
       SelectedOnly  As Long
       Replace       As Long
       ReplaceAll    As Long
       Prompt        As Long
end type

type T_SPECIALLINEINFO
       ErrorLine  As Long
       BreakLine  As Long
       ErrorColor As Long
       BreakColor As Long
end type

type T_GUTTER
     Gradient     As Long
     GradientStep As Long
     StartColor   As Long
     EndColor     As Long
     FontName     As Long
     FontSize     As Long
     FontColor    As Long
end type

type T_GUTTEREVENT
    x    As Long
    y    As Long
    mb   As Long
    line As Long
end type

type T_GUTTERPAINTEVENT
    line   As Long
    x      As Long
    y      As Long
end type

type T_COMPLETION
     ClBackground      As Long
     ClSelect          As Long
     ClSelectedText    As Long
     ClTitleBackground As Long
     DefaultType       As Long
     EndOfTokenChr     As Long
     Margin            As Long
     NbLinesInWindow   As Long
     ItemHeight        As Long
     Resizeable        As Long
     TimerInterval     As Long
     TriggerChars      As Long
     ShortCut          As Long
     Title             As Long
     Width             As Long
end type

type T_KEYSTROKE
     Command   As Long
     Keystroke As Long
end type

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Declare Function Editor_Create Lib "SuperEdit.dll" Alias "Editor_Create"(Parent As Long,Left As Integer,Top As Integer,Width As Integer,Height As Integer) As Long
Declare Sub Editor_Free Lib "SuperEdit.dll" Alias "Editor_Free"(hWnd As Long)
Declare Sub SetDLLHost Lib "SuperEdit.dll" Alias "SetDLLHost"(hWnd As Long)
Declare Sub FreeAll Lib "SuperEdit.dll" Alias "FreeAll"()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
$IFNDEF __XPTHEME

Const BP_GROUPBOX     = &H4
Const TMT_BORDERCOLOR = &HED9
Const TMT_TEXTCOLOR   = &HEDB
Const TMT_MENUFONT    = &H323

Type MARGINS
     cxLeftWidth    As Long
     cxRightWidth   As Long
     cyTopHeight    As Long
     cyBottomHeight As Long
End Type

Declare Function CloseThemeData Lib "uxtheme" Alias "CloseThemeData" (hTheme As Long) As Long
Declare Function DrawThemeBackground Lib "uxtheme" Alias "DrawThemeBackground" (hTheme As Long, hDC As Long, iPartId As Long, iStateId As Long, pRect As RECT, pClipRect As RECT) As Long
Declare Function DrawThemeParentBackground Lib "uxtheme" Alias "DrawThemeParentBackground" (hWnd As Long, hDC As Long, prc As RECT) As Long
Declare Function GetThemeInt Lib "uxtheme" Alias "GetThemeInt" (hTheme As Long, iPartId As Long, iStateId As Long, iPropId As Long, piVal As Long) As Long
Declare Function GetThemeSysFont Lib "uxtheme" Alias "GetThemeSysFont" (hTheme As Long, iFontID As Long, plf As LOGFONT) As Long
Declare Function OpenThemeData Lib "uxtheme" Alias "OpenThemeData" (hWnd As Long, pszClassList As String) As Long

$ENDIF
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Declare Sub EventTemplate_SuperEditClick(BYREF Sender&)
Declare Sub EventTemplate_SuperEditDblClick(BYREF Sender&)
Declare Sub EventTemplate_SuperEditChange(BYREF Sender&)
Declare Sub EventTemplate_SuperEditMouseCursor(BYREF Sender&,Line$)
Declare Sub EventTemplate_SuperEditGutterClick(BYREF Sender&,x&,y&,Button&,Line&)
Declare Sub EventTemplate_SuperEditKeyPress(BYREF Sender&,Key As Byte)
Declare Sub EventTemplate_SuperEditKeyDown(BYREF Sender&,Key As Word,Shift&)
Declare Sub EventTemplate_SuperEditKeyUp(BYREF Sender&,Key As Word,Shift&)
Declare Sub EventTemplate_SuperEditEnter(BYREF Sender&)
Declare Sub EventTemplate_SuperEditExit(BYREF Sender&)
Declare Sub EventTemplate_SuperEditScroll(BYREF Sender&,ScrollBar&)
Declare Sub EventTemplate_SuperEditPaint(BYREF Sender&,Canvas&)
Declare Sub EventTemplate_SuperEditGutterPaint(BYREF Sender&,Canvas&,Line&,x&,y&)
Declare Sub EventTemplate_SuperEditStatusChange(BYREF Sender&,Status&)
Declare Sub EventTemplate_SuperEditMouseDown(BYREF Sender&,Button&,x&,y&,Shift&)
Declare Sub EventTemplate_SuperEditMouseMove(BYREF Sender&,x&,y&,Shift&)
Declare Sub EventTemplate_SuperEditMouseUp(BYREF Sender&,Button&,x&,y&,Shift&)
Declare Sub EventTemplate_SuperEditDropFiles(BYREF Sender&,x&,y&,Files As QStringList)
Type QSuperEdit ExtEnds QObject
    Private:
    ParentWnd                 As Integer
    ParentLastProc            As Integer
    EditorLastProc            As Integer
    ParentProc                As Integer
    EditorProc                As Integer
    Public:
    Keywords                  As QStringList
    Handle                    As Integer
    Parent                    As QForm   Property Set SetParent
    Parent2                   As QPanel  Property Set SetParent2
    Left                      As Integer Property Set SetLeft
    Top                       As Integer Property Set SetTop
    Width                     As Integer Property Set SetWidth
    Height                    As Integer Property Set SetHeight
    Enabled                   As Integer Property Set SetEnabled
    Visible                   As Integer Property Set SetVisible
    Color                     As Integer Property Set SetColor
    ReadOnly                  As Integer Property Set SetReadOnly
    Text                      As String  Property Set SetText
    CaretX                    As Integer Property Set SetCaretX
    CaretY                    As Integer Property Set SetCaretY
    TopLine                   As Integer Property Set SetTopLine
    ErrorLine                 As Integer Property Set SetErrorLine
    BreakLine                 As Integer Property Set SetBreakLine
    ErrorLineColor            As Integer Property Set SetErrorLineColor
    BreakLineColor            As Integer Property Set SetBreakLineColor
    ActiveLineColor           As Integer Property Set SetActiveLineColor
    Font.Name                 As String  Property Set SetFont.Name
    Font.Size                 As Integer Property Set SetFont.Size
    WordWrap                  As Integer Property Set SetWordWrap
    DoubleQuoteString         As Integer Property Set SetDoubleQuoteString
    DetectPreproccesor        As Integer Property Set SetDetectPreproccesor
    SelText                   As String  Property Set SetSelText
    SelLength                 As Integer Property Set SetSelLength
    SelStart                  As Integer Property Set SetSelStart
    AllowCompletion           As Integer Property Set SetAllowCompletion
    WindowCompletionStrings   As String  Property Set SetWindowCompletionStrings
    WindowCompletionTemplate  As String  Property Set SetWindowCompletionTemplate
    HintCompletionStrings     As String  Property Set SetHintCompletionStrings
    HintCompletionTemplate    As String  Property Set SetHintCompletionTemplate
    Selection.Mode            As Integer Property Set SetSelection.Mode
    Selection.Background      As Integer Property Set SetSelection.Background
    Selection.Foreground      As Integer Property Set SetSelection.Foreground
    Gutter.Width              As Integer Property Set SetGutter.Width
    Gutter.Color              As Integer Property Set SetGutter.Color
    Gutter.Visible            As Integer Property Set SetGutter.Visible
    Gutter.LineNumbers        As Integer Property Set SetGutter.LineNumbers
    Gutter.Gradient           As Integer Property Set SetGutter.Gradient
    Gutter.GradientStep       As Integer Property Set SetGutter.GradientStep
    Gutter.StartColor         As Integer Property Set SetGutter.StartColor
    Gutter.EndColor           As Integer Property Set SetGutter.EndColor
    Gutter.Font.Name          As String  Property Set SetGutter.Font.Name
    Gutter.Font.Size          As Integer Property Set SetGutter.Font.Size
    Gutter.Font.Color         As Integer Property Set SetGutter.Font.Color
    Keywords.Background       As Integer Property Set SetKeywords.Background
    Keywords.Foreground       As Integer Property Set SetKeywords.Foreground
    Keywords.Bold             As Integer Property Set SetKeywords.Bold
    Keywords.Italic           As Integer Property Set SetKeywords.Italic
    Keywords.Underline        As Integer Property Set SetKeywords.Underline
    Keywords.Strikeout        As Integer Property Set SetKeywords.Strikeout
    Strings.Background        As Integer Property Set SetStrings.Background
    Strings.Foreground        As Integer Property Set SetStrings.Foreground
    Strings.Bold              As Integer Property Set SetStrings.Bold
    Strings.Italic            As Integer Property Set SetStrings.Italic
    Strings.Underline         As Integer Property Set SetStrings.Underline
    Strings.Strikeout         As Integer Property Set SetStrings.Strikeout
    Numbers.Background        As Integer Property Set SetNumbers.Background
    Numbers.Foreground        As Integer Property Set SetNumbers.Foreground
    Numbers.Bold              As Integer Property Set SetNumbers.Bold
    Numbers.Italic            As Integer Property Set SetNumbers.Italic
    Numbers.Underline         As Integer Property Set SetNumbers.Underline
    Numbers.Strikeout         As Integer Property Set SetNumbers.Strikeout
    Symbols.Background        As Integer Property Set SetSymbols.Background
    Symbols.Foreground        As Integer Property Set SetSymbols.Foreground
    Symbols.Bold              As Integer Property Set SetSymbols.Bold
    Symbols.Italic            As Integer Property Set SetSymbols.Italic
    Symbols.Underline         As Integer Property Set SetSymbols.Underline
    Symbols.Strikeout         As Integer Property Set SetSymbols.Strikeout
    Comments.Background       As Integer Property Set SetComments.Background
    Comments.Foreground       As Integer Property Set SetComments.Foreground
    Comments.Bold             As Integer Property Set SetComments.Bold
    Comments.Italic           As Integer Property Set SetComments.Italic
    Comments.Underline        As Integer Property Set SetComments.Underline
    Comments.Strikeout        As Integer Property Set SetComments.Strikeout
    PopupMenu                 As Integer Property Set SetPopupMenu
    MaxUndo                   As Integer Property Set SetMaxUndo
    TabWidth                  As Integer Property Set SetTabWidth
    TabStop                   As Integer Property Set SetTabStop
    WantTabs                  As Integer Property Set SetWantTabs
    InsertMode                As Integer Property Set SetInsertMode
    InsertCaret               As Integer Property Set SetInsertCaret
    OverwriteCaret            As Integer Property Set SetOverwriteCaret
    HideSelection             As Integer Property Set SetHideSelection
    RightEdge                 As Integer Property Set SetRightEdge
    RightEdgeColor            As Integer Property Set SetRightEdgeColor
    ScrollBars                As Integer Property Set SetScrollBars
    Hint                      As String  Property Set SetHint
    ShowHint                  As Integer Property Set SetShowHint
    ScrollHintFormat          As Integer Property Set SetScrollHintFormat
    ScrollHintColor           As Integer Property Set SetScrollHintColor
    Tag                       As Integer
    
    OnClick                   As Event(EventTemplate_SuperEditClick)
    OnDblClick                As Event(EventTemplate_SuperEditDblClick)
    OnChange                  As Event(EventTemplate_SuperEditChange)
    OnMouseCursor             As Event(EventTemplate_SuperEditMouseCursor)
    OnGutterClick             As Event(EventTemplate_SuperEditGutterClick)
    OnKeyPress                As Event(EventTemplate_SuperEditKeyPress)
    OnKeyDown                 As Event(EventTemplate_SuperEditKeyDown)
    OnKeyUp                   As Event(EventTemplate_SuperEditKeyUp)
    OnScroll                  As Event(EventTemplate_SuperEditScroll)
    OnStatusChange            As Event(EventTemplate_SuperEditStatusChange)
    OnEnter                   As Event(EventTemplate_SuperEditEnter)
    OnExit                    As Event(EventTemplate_SuperEditExit)
    OnPaint                   As Event(EventTemplate_SuperEditPaint)
    OnGutterPaint             As Event(EventTemplate_SuperEditGutterPaint)
    OnMouseDown               As Event(EventTemplate_SuperEditMouseDown)
    OnMouseMove               As Event(EventTemplate_SuperEditMouseMove)
    OnMouseUp                 As Event(EventTemplate_SuperEditMouseUp)
    OnDropFiles               As Event(EventTemplate_SuperEditDropFiles)
    
    With This
    
    Private:
    
    Function ParentWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
        Dim P As Point
        Result = CallWindowProc(.ParentLastProc,hWnd&,Msg&,wParam&,lParam&)
        Select Case Msg&
        Case WM_NOTIFY
             Dim NM As NMHDR
             MemCpy NM,LParam&,SizeOf(NM)
             Select Case NM.Code
             Case SEN_CLICK
                  SEndMessage(.Handle,SEM_GETCARETXY,0,P)
                  .CaretX = P.x
                  .CaretY = P.y
                  If .OnClick Then CallFunc .OnClick,.Handle
             Case SEN_DBLCLICK
                  SEndMessage(.Handle,SEM_GETCARETXY,0,P)
                  .CaretX = P.x
                  .CaretY = P.y
                  If .OnDblClick Then CallFunc .OnDblClick,.Handle
             Case SEN_CHANGE
                  MemCpy P,WParam&,SizeOf(P)
                  .CaretX = P.x
                  .CaretY = P.y
                  If .OnClick Then CallFunc .OnChange,.Handle
             Case SEN_SCROLL
                  If .OnScroll Then CallFunc .OnScroll,.Handle,wParam&
             Case SEN_PAINT
                  If .OnPaint Then CallFunc .OnPaint,.Handle,wParam&
             End Select
        End Select
    End Function
    
    Function EditorWndProc(hWnd&,Msg&,wParam&,lParam&) As Integer
        Result = CallWindowProc(.EditorLastProc,hWnd&,Msg&,wParam&,lParam&)
        Select Case Msg&
        Case WM_NCPAINT
             If ((GetVersion And 255) + (GetVersion And &HFF00) / 25600) >= 5.01 Then
                If FileExists(Application.ExeName & ".manifest") Then
                   DefLng hTheme, hDC, hBrush, BorderColor, Style, ExStyle
                   Dim R As RECT
                   hTheme = OpenThemeData(hWnd&,"E"+CHR$(0)+"D"+CHR$(0)+"I"+CHR$(0)+"T"+CHR$(0)+CHR$(0)+CHR$(0))
                   If hTheme Then
                      GetThemeInt(hTheme, 1, 1, TMT_BORDERCOLOR, @BorderColor)
                      CloseThemeData(hTheme)
                      ExStyle = GetWindowLong(hWnd&, GWL_EXSTYLE)
                      If ExStyle And WS_EX_CLIENTEDGE Then
                         SetWindowLong(hWnd&, GWL_EXSTYLE, ExStyle And (Not WS_EX_CLIENTEDGE))
                         SetWindowLong(hWnd&, GWL_STYLE, GetWindowLong(hWnd&, GWL_STYLE) OR WS_BORDER)
                         SetWindowPos(hWnd&,0,0,0,0,0,SWP_FRAMECHANGED OR SWP_NOACTIVATE OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOZORDER)
                      End If
                      hDC = GetWindowDC(hWnd&)
                      GetWindowRect(hWnd&, R)
                      R.Right  = R.Right  - R.Left
                      R.Bottom = R.Bottom - R.Top
                      R.Top  = 0
                      R.Left = 0
                      hBrush = CreateSolidBrush(BorderColor)
                      SelectObject(hDC, hBrush)
                      FrameRect(hDC, R, hBrush)
                      DeleteObject(hBrush)
                   End If
                Else
                   Style = GetWindowLong(hWnd&, GWL_STYLE)
                   If Style And WS_BORDER Then
                      SetWindowLong(hWnd&, GWL_STYLE, Style And (Not WS_BOrDER))
                      SetWindowLong(hWnd&, GWL_EXSTYLE, GetWindowLong(hWnd&, GWL_EXSTYLE) Or WS_EX_CLIENTEDGE)
                      SetWindowPos(hWnd&,0,0,0,0,0,SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZOrDER)
                   End If
                End If
             End If
        Case WM_WINDOWPOSCHANGING
             Dim WP As WINDOWPOS
             MemCpy WP,LParam&,SizeOf(WP)
             .Left   = WP.x
             .Top    = WP.y
             .Width  = WP.cx
             .Height = WP.cy
        Case WM_SETTEXT
             .Text = VarPTR$(LParam&)
        Case SEM_SETTEXT
             .Text = VarPTR$(LParam&)
        Case SEM_SETTOPLINE
             .TopLine = wParam&
        Case SEM_SETKEYWOrDS
             .KeywOrds.Text = VarPTR$(LParam&)
        Case SEM_ADDKEYWOrD
             .KeywOrds.AddItems VarPTR$(LParam&)
        Case SEM_DELETEKEYWORD
             .KeywOrds.DelItems .KeywOrds.IndexOf(VarPTR$(LParam&))
        Case SEN_MOUSECURSOR
             DefInt LinePtr
             SEndMessage(hWnd&,SEM_GETLINETEXT,LParam&-1,VarPTR(LinePtr))
             DefStr LineText = VarPTR$(LinePtr)
             If .OnMouseCursOr Then CallFunc .OnMouseCursOr,.Handle,LineText
        Case SEN_GUTTERCLICK
             Dim GTE As T_GUTTEREVENT
             MemCpy GTE,lParam&,SizeOf(GTE)
             If .OnGutterClick Then CallFunc .OnGutterClick,.Handle,GTE.x,GTE.y,GTE.mb,GTE.Line
        Case SEN_KEYPRESS
             If .OnKeyPress Then CallFunc .OnKeyPress, .Handle, BYTE(LParam&)
        Case SEN_DROPFILES
             DefInt i
             Dim Files As QStringList
             Dim P As Point,L As Point
             MemCpy P,wParam&,SizeOf(P)
             MemCpy L,LParam&,SizeOf(L)
             ReDim A(L.x) As Integer
             Files.Clear
             If L.y Then
                MemCpy VarPTR(A(0)),L.y,L.x * 4
                For i = 0 To L.x -1
                    Files.AddItems VarPTR$(A(i))
                Next i
             End If
             If .OnDropFiles Then CallFunc .OnDropFiles,.Handle,P.x,P.y,Files
        Case WM_KEYDOWN
             If .OnKeyDown Then CallFunc .OnKeyDown, .Handle, WORD(wParam&),wParam& And &HFFFF
        Case WM_KEYUP
             If .OnKeyUp Then CallFunc .OnKeyUp, .Handle, WORD(wParam&),wParam& And &HFFFF
        Case SEN_ENTER
             If .OnEnter Then CallFunc .OnEnter, .Handle
        Case SEN_EXIT
             If .OnExit Then CallFunc .OnExit, .Handle
        Case SEN_STATUSCHANGE
             If .OnStatusChange Then CallFunc .OnStatusChange, .Handle, wParam&
        Case SEN_GUTTERPAINT
             Dim GPE As T_GUTTERPAINTEVENT
             MemCpy GPE,LParam&,SizeOf(GPE)
             If .OnGutterPaint Then CallFunc .OnGutterPaint, .Handle, wParam&, GPE.Line, GPE.x, GPE.y
        Case WM_LBUTTONDOWN
             If .OnMouseDown Then CallFunc .OnMouseDown,.Handle,0,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF
        Case WM_LBUTTONUP
             If .OnMouseUp Then CallFunc .OnMouseUp,.Handle,0,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF
        Case WM_RBUTTONDOWN
             If .OnMouseDown Then CallFunc .OnMouseDown,.Handle,1,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF
        Case WM_RBUTTONUP
             P.x = LoWord(lParam&)
             P.y = HiWord(lParam&)
             ClientToScreen(.Handle,P)
             TrackPopUpMenu(.PopupMenu,TPM_LEFTALIGN,P.x,P.y,0,.Handle,0)
             If .OnMouseUp Then CallFunc .OnMouseUp,.Handle,1,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF
        Case WM_MOUSEMOVE
             If .OnMouseMove Then CallFunc .OnMouseMove,.Handle,LoWord(lParam&),HiWord(lParam&),wParam& And &HFFFF
        End Select
    End Function
    
    Sub CreateWnd
        Dim P As Point
        DefInt FG,BG,Ptr
        If .Handle Then Exit Sub
        .Handle = EditOr_Create(.ParentWnd,.Left,.Top,.Width,.Height)
        .EditOrLastProc = SetWindowLong(.Handle,GWL_WNDPROC,.EditOrProc)
        SEndMessage(.Handle,SEM_GETCARETXY,0,P)
        .CaretX = P.x
        .CaretY = P.y
        .ColOr  = SEndMessageA(.Handle,SEM_GETBKCOLOr,0,0)
        .Selection.Mode = SEndMessageA(.Handle,SEM_GETSELECTIONMODE,0,0)
        SEndMessage(.Handle,SEM_GETSELECTIONCOLOr,VarPTR(BG),VarPTR(FG))
        .Selection.Background = BG
        .Selection.FOreground = FG
        .Gutter.Width = SEndMessageA(.Handle,SEM_GETGUTTERWIDTH,0,0)
        .Gutter.ColOr = SEndMessageA(.Handle,SEM_GETGUTTERCOLOr,0,0)
        Ptr = SendMessageA(.Handle,SEM_GETFONTNAME,0,0)
        .Font.Name = VarPTR$(Ptr)
        .Font.Size = SendMessageA(.Handle,SEM_GETFONTSIZE,0,0)
    End Sub
    
    Public:
    
    Function Count() As Integer
        Result = SEndMessageA(.Handle,SEM_LINECOUNT,0,0)
    End Function
    
    Function GetLine(Index&) As String
        DefInt LinePtr
        Result = ""
        If Index& > -1 And Index& < .Count Then
           SEndMessage(.Handle,SEM_GETLINETEXT,Index&,VarPTR(LinePtr))
           DefStr LineText = VarPTR$(LinePtr)
           Result = LineText
        End If
    End Function
    
    Sub SetLine(Index&,Line$)
        DefStr LineText
        If Index& > -1 And Index& < .Count Then
           LineText = Line$
           SEndMessage(.Handle,SEM_SETLINETEXT,Index&,VarPTR(LineText))
        End If
    End Sub
    
    SubI AddOptions(...)
         DefInt i
         If .Handle Then
            FOr i = 1 To ParamValCount
                SendMessage(.Handle,SEM_SETOPTIONS,ParamVal(i),1)
            Next i
         End If
    End SubI
    
    SubI DelOptions(...)
         DefInt i
         If .Handle Then
            FOr i = 1 To ParamValCount
                SendMessage(.Handle,SEM_SETOPTIONS,ParamVal(i),0)
            Next i
         End If
    End SubI
    
    Sub AddKeyWord(KeywOrd$)
         DefStr s = ""
         If .Handle Then
            s = KeywOrd$
            SendMessage(.Handle,SEM_ADDKEYWOrD,0,VarPTR(s))
         End If
    End Sub

    Sub DelKeyWord(KeywOrd$)
         DefStr s = ""
         If .Handle Then
            s = KeywOrd$
            SendMessage(.Handle,SEM_DELETEKEYWOrD,0,VarPTR(s))
         End If
    End Sub
    
    SubI AddKeyWOrds(...)
         DefInt i
         If .Handle Then
            FOr i = 1 To ParamStrCount
                .AddKeyWOrd(ParamStr$(i))
            Next i
         End If
    End SubI
    
    SubI DelKeyWOrds(...)
         DefInt i
         If .Handle Then
            FOr i = 1 To ParamStrCount
                .DelKeyWOrd(ParamStr$(i))
            Next i
         End If
    End SubI
    
    Function AddBookMarkBMP(BMPFile$,ColorTransparent&) As Integer
        DefStr s = BMPFile$
        If .Handle Then
           Result = SendMessageA(.Handle,SEM_ADDBOOKMARKBMP,ColorTransparent&,VarPTR(s))
        End If
    End Function
    
    FunctionI AddBookMarkBMPs(...) As Integer
         DefInt i
         If .Handle Then
            FOr i = 1 To ParamStrCount
                DefStr s = ParamStr$(i)
                Result = SendMessageA(.Handle,SEM_ADDBOOKMARKBMP,IIf(ParamValCount,ParamVal(1),0),VarPTR(s))
            Next i
         End If
    End FunctionI
    
    Sub SetBookMark(BMPIndex&,Line&)
        Dim P As Point
        P.x = 0
        P.y = Line&
        If .Handle Then
           SEndMessage(.Handle,SEM_SETBOOKMARK,BMPIndex&,P)
        End If
    End Sub
    
    Sub DelBookMark(BMPIndex&)
        If .Handle Then
           SendMessage(.Handle,SEM_DELBOOKMARK,BMPIndex&,0)
        End If
    End Sub
    
    Sub AddCommentStyle(CommentStyle&)
        If CommentStyle& > -1 And CommentStyle& < 6 Then
           If .Handle Then
              SendMessage(.Handle,SEM_SETCOMMENTSTYLE,1,CommentStyle&)
           End If
        End If
    End Sub
    
    SubI AddCommentStyles(...)
         DefInt i
         FOr i = 0 To ParamValCount
             .AddCommentStyle ParamVal(i)
         Next i
    End SubI
    
    Sub DelCommentStyle(CommentStyle&)
        If CommentStyle& > -1 And CommentStyle& < 6 Then
           If .Handle Then
              SendMessage(.Handle,SEM_SETCOMMENTSTYLE,0,CommentStyle&)
           End If
        End If
    End Sub
    
    SubI DelCommentStyles(...)
         DefInt i
         FOr i = 0 To ParamValCount
             .DelCommentStyle ParamVal(i)
         Next i
    End SubI
    
    Sub LoadFromFile(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_LOADFROMFILE,0,VarPTR(s))
        End If
    End Sub
    
    Sub SaveToFile(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_SAVETOFILE,0,VarPTR(s))
        End If
    End Sub
    
    Sub LoadHighlighterFromFile(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_LOADATTRIBUTESFROMINI,0,VarPTR(s))
        End If
    End Sub

    Sub SaveHighlighterToFile(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_SAVEATTRIBUTESTOINI,0,VarPTR(s))
        End If
    End Sub
    
    Sub ExportHtml(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_EXPORTHTML,0,VarPTR(s))
        End If
    End Sub
    
    Sub ExportRtf(File$)
        DefStr s = File$
        If .Handle Then
           SendMessage(.Handle,SEM_EXPORTRTF,0,VarPTR(s))
        End If
    End Sub
    
    Sub PrintDocument(Title$,Header$,Footer$,FontFace$,FontSize&,PrintColor&)
        Dim PIF As T_PRINTINFO
        PIF.Title      = NewZStr(Title$)
        PIF.Header     = NewZStr(Header$)
        PIF.Footer     = NewZStr(Footer$)
        PIF.FontFace   = NewZStr(FontFace$)
        PIF.FontSize   = FontSize&
        PIF.PrintColor = PrintColor&
        If .Handle Then
           SendMessage(.Handle,SEM_PRINT,0,PIF)
        End If
    End Sub
    
    Function IndexOf(s$) As Integer
        DefStr s = s$
        Result = -1
        If .Handle Then Result = SendMessageA(.Handle,SEM_INDEXOF,0,VarPTR(s))
    End Function
    
    Sub Exchange(Index1&,Index2&)
        If Index1& > -1 And Index1& < .Count And _
           Index2& > -1 And Index2& < .Count Then
           If .Handle Then SendMessage(.Handle,SEM_EXCHANGE,Index1&,Index2&)
        End If
    End Sub
    
    Sub AddLine(Line$)
        DefStr s = Line$
        If .Handle Then SendMessage(.Handle,SEM_ADDLINE,0,VarPTR(s))
    End Sub
    
    SubI AddLines(...)
         DefInt i
         For i = 1 To ParamStrCount
             .AddLine(ParamStr$(i))
         Next i
    End SubI
    
    Sub InsertLine(Index&,Line$)
        DefStr s = Line$
        If Index& > -1 Then
           If .Handle Then SendMessage(.Handle,SEM_INSERTLINE,Index&,VarPTR(s))
        End If
    End Sub
    
    Sub DelLine(Index&)
        If Index& > -1 And Index& < .Count Then
           If .Handle Then SendMessage(.Handle,SEM_DELLINE,Index&,0)
        End If
    End Sub
    
    SubI DelLines(...)
         DefInt i
         For i = 1 To ParamValCount
             .DelLine(ParamVal(i))
         Next i
    End SubI
    
    Function Find(Token$,MatchCase&,WholeWord&,Backwards&,EntireScope&,SelectedOnly&) As Integer
        Dim SR As T_SEARCHREPLACE
        SR.FindString    = NewZStr(Token$)
        SR.ReplaceString = 0
        SR.MatchCase     = MatchCase&
        SR.WholeWord     = WholeWord&
        SR.Backwards     = Backwards&
        SR.EntireScope   = EntireScope&
        SR.SelectedOnly  = SelectedOnly&
        SR.Replace       = 0
        SR.ReplaceAll    = 0
        SR.Prompt        = 0
        Result = 1
        If .Handle Then
           Result = SendMessageA(.Handle,SEM_FINDSTRING,0,SR)
        End If
    End Function
    
    Function Replace(Token$,ReplaceWith$,MatchCase&,WholeWord&,Backwards&,EntireScope&,SelectedOnly&,Replace&,ReplaceAll&) As Integer
        Dim SR As T_SEARCHREPLACE
        SR.FindString    = NewZStr(Token$)
        SR.ReplaceString = NewZStr(ReplaceWith$)
        SR.MatchCase     = MatchCase&
        SR.WholeWord     = WholeWord&
        SR.Backwards     = Backwards&
        SR.EntireScope   = EntireScope&
        SR.SelectedOnly  = SelectedOnly&
        SR.Replace       = Replace&
        SR.ReplaceAll    = ReplaceAll&
        SR.Prompt        = 0
        Result = 1
        If .Handle Then
           Result = SendMessageA(.Handle,SEM_REPLACESTRING,0,SR)
        End If
    End Function
    
    Sub AddKeystroke(Command&,Keystroke$)
        Dim KS As T_KEYSTROKE
        KS.Command   = Command&
        KS.Keystroke = NewZStr(Keystroke$)
        If .Handle Then
           SendMessage(.Handle,SEM_ADDKEYSTROKE,0,KS)
        End If
    End Sub
    
    Sub DelKeystroke(Keystroke$)
        Dim KS As T_KEYSTROKE
        KS.Command   = 0
        KS.Keystroke = NewZStr(Keystroke$)
        If .Handle Then
           SendMessage(.Handle,SEM_DELKEYSTROKE,0,KS)
        End If
    End Sub

    Function CanRedo() As Integer
        Result = SendMessageA(.Handle,SEM_CANREDO,0,0)
    End Function
    
    Function CanUndo() As Integer
        Result = SendMessageA(.Handle,SEM_CANUNDO,0,0)
    End Function
    
    Function CanPaste() As Integer
        Result = SendMessageA(.Handle,SEM_CANPASTE,0,0)
    End Function

    Sub Redo
        If .Handle Then SendMessage(.Handle,SEM_REDO,0,0)
    End Sub
    
    Sub Undo
        If .Handle Then SendMessage(.Handle,SEM_UNDO,0,0)
    End Sub
    
    Sub CutToClipboard
        If .Handle Then SendMessage(.Handle,SEM_CUT,0,0)
    End Sub
    
    Sub CopyToClipboard
        If .Handle Then SendMessage(.Handle,SEM_COPY,0,0)
    End Sub
    
    Sub PasteFromClipboard
        If .Handle Then SendMessage(.Handle,SEM_PASTE,0,0)
    End Sub
    
    Sub SelectAll
        If .Handle Then SendMessage(.Handle,SEM_SELECTALL,0,0)
    End Sub
    
    Sub Repaint
        If .Handle Then SendMessage(.Handle,SEM_REPAINT,0,0)
    End Sub
    
    Sub InvalidateGutter
        If .Handle Then SendMessage(.Handle,SEM_INVALIDATEGUTTER,0,0)
    End Sub
    
    Sub Invalidate
        If .Handle Then SendMessage(.Handle,SEM_INVALIDATE,0,0)
    End Sub
    
    Sub Update
        If .Handle Then SendMessage(.Handle,SEM_UPDATE,0,0)
    End Sub
    
    Sub SetFocus
        If .Handle Then SetFocus(.Handle)
    End Sub
    
    Sub BringToFront
        If .Handle Then BringWindowToTop(.Handle)
    End Sub
    
    Sub Clear
        If .Handle Then SendMessage(.Handle,SEM_CLEAR,0,0)
    End Sub

    Sub Free
        EditOr_Free(.Handle)
    End Sub
    
    Sub SetWindowCompletionInfo(CIF As T_COMPLETION)
        If .Handle Then
           SendMessage(.Handle,SEM_SETCOMPLETIONINFO,0,CIF)
        End If
    End Sub
    
    Sub GetWindowCompletionInfo(BYREF CIF As T_COMPLETION)
        If .Handle Then
           SendMessage(.Handle,SEM_SETCOMPLETIONINFO,0,CIF)
        End If
    End Sub
    
    Sub SetHintCompletionInfo(CIF As T_COMPLETION)
        If .Handle Then
           SendMessage(.Handle,SEM_SETCOMPLETIONINFO,1,CIF)
        End If
    End Sub

    Sub GetHintCompletionInfo(BYREF CIF As T_COMPLETION)
        If .Handle Then
           SendMessage(.Handle,SEM_SETCOMPLETIONINFO,1,CIF)
        End If
    End Sub
    
    Property Set SetParent(Value As QFOrm)
        DefInt SaveParent = .ParentWnd
        If Value.Handle <> .ParentWnd Then
           .ParentWnd = Value.Handle
           If .Handle Then
              SetParent(.Handle,.ParentWnd)
              If SaveParent Then SetWindowLong(SaveParent,GWL_WNDPROC,.ParentLastProc)
              .ParentLastProc = SetWindowLong(.ParentWnd,GWL_WNDPROC,.ParentProc)
           Else
              .CreateWnd
              If .ParentWnd Then .ParentLastProc = SetWindowLong(.ParentWnd,GWL_WNDPROC,.ParentProc)
           End If
        End If
    End Property
    
    Property Set SetParent2(Value As QPanel)
        DefInt SaveParent = .ParentWnd
        If Value.Handle <> .ParentWnd Then
           .ParentWnd = Value.Handle
           If .Handle Then
              SetParent(.Handle,.ParentWnd)
              If SaveParent Then SetWindowLong(SaveParent,GWL_WNDPROC,.ParentLastProc)
              .ParentLastProc = SetWindowLong(.ParentWnd,GWL_WNDPROC,.ParentProc)
           Else
              .CreateWnd
              If .ParentWnd Then .ParentLastProc = SetWindowLong(.ParentWnd,GWL_WNDPROC,.ParentProc)
           End If
        End If
    End Property
    
    Property Set SetPopupMenu(Value As Integer)
        .PopupMenu = Value
        If .PopupMenu Then
           If .Handle Then SendMessage(.Handle,SEM_SETPOPUPMENU,0,0)
        Else
           If .Handle Then SendMessage(.Handle,SEM_SETPOPUPMENU,1,0)
        End If
    End Property
    
    Property Set SetLeft(Value As Integer)
        .Left = Value
        If .Handle Then MoveWindow(.Handle,Value,.Top,.Width,.Height,1)
    End Property
    
    Property Set SetTop(Value As Integer)
        .Top  = Value
        If .Handle Then MoveWindow(.Handle,.Left,Value,.Width,.Height,1)
    End Property
    
    Property Set SetWidth(Value As Integer)
        .Width = Value
        If .Handle Then MoveWindow(.Handle,.Left,.Top,Value,.Height,1)
    End Property
    
    Property Set SetHeight(Value As Integer)
        .Height = Value
        If .Handle Then MoveWindow(.Handle,.Left,.Top,.Width,Value,1)
    End Property
    
    Property Set SetColOr(Value As Integer)
        .ColOr = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETBKCOLOr,0,.ColOr)
    End Property
    
    Property Set SetEnabled (Value As Integer)
        .Enabled = Value
        If .Handle Then EnableWindow(.Handle,.Enabled)
    End Property
    
    Property Set SetVisible(Value As Integer)
        .Visible = Value
        If .Handle Then ShowWindow(.Handle,IIf(Value,SW_SHOW,SW_HIDE))
    End Property
    
    Property Set SetReadOnly(Value As Integer)
        .ReadOnly = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETREADONLY,.ReadOnly,0)
    End Property
    
    Property Set SetText(Value As String)
        .Text = Value
        DefStr s = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETTEXT,0,VarPTR(s))
    End Property
    
    Property Set SetCaretX(Value As Integer)
        Dim P As Point
        .CaretX = Value
        P.x = .CaretX
        P.y = .CaretY
        If .Handle Then SEndMessage(.Handle,SEM_SETCARETXY,0,P)
    End Property
    
    Property Set SetCaretY(Value As Integer)
        Dim P As Point
        .CaretY = Value
        P.x = .CaretX
        P.y = .CaretY
        If .Handle Then SEndMessage(.Handle,SEM_SETCARETXY,0,P)
    End Property
    
    Property Set SetTopLine(Value As Integer)
        .TopLine = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETTOPLINE,.TopLine,0)
    End Property
    
    Property Set SetWOrdWrap(Value As Integer)
       .WOrdWrap = Value
       If .Handle Then
           SEndMessage(.Handle,SEM_SETWOrDWRAP,Value,0)
        End If
    End Property
    
    Property Set SetFont.Name(Value As String)
        DefStr s = Value
        .Font.Name = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_SETFONTNAME,0,VarPTR(s))
        End If
    End Property
    
    Property Set SetFont.Size(Value As Integer)
        .Font.Size = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_SETFONTSIZE,Value,0)
        End If
    End Property
    
    Property Set SetErrorLine(Value As Integer)
        Dim LIf As T_SPECIALLINEINFO
        .ErrOrLine = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSPECIALLINEINFO,0,LIf)
           LIf.ErrOrLine = .ErrOrLine
           SEndMessage(.Handle,SEM_SETSPECIALLINEINFO,0,LIf)
        End If
    End Property
    
    Property Set SetErrorLineColOr(Value As Integer)
        Dim LIf As T_SPECIALLINEINFO
        .ErrOrLineColOr = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSPECIALLINEINFO,0,LIf)
           LIf.ErrOrColOr = Value
           SEndMessage(.Handle,SEM_SETSPECIALLINEINFO,0,LIf)
        End If
    End Property
    
    Property Set SetBreakLineColOr(Value As Integer)
        Dim LIf As T_SPECIALLINEINFO
        .BreakLineColOr = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSPECIALLINEINFO,0,LIf)
           LIf.BreakColOr = Value
           SEndMessage(.Handle,SEM_SETSPECIALLINEINFO,0,LIf)
        End If
    End Property
    
    Property Set SetActiveLineColOr(Value As Integer)
        .ActiveLineColOr = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETACTIVELINECOLOR,0,.ActiveLineColOr)
    End Property
    
    Property Set SetDoubleQuoteString(Value As Integer)
        .DoubleQuoteString = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_SETDOUBLEQUOTES,Value,0)
        End If
    End Property
    
    Property Set SetDetectPreproccesor(Value As Integer)
        .DetectPreproccesor = Value
        If .Handle Then
           SendMessage(.Handle,SEM_DETECTPREPROCESSOR,Value,0)
        End If
    End Property
    
    Property Set SetSelText(Value As String)
        .SelText = Value
        If .Handle Then
           DefStr s = Value
           SendMessage(.Handle,SEM_SETSELTEXT,0,VarPTR(s))
           .SelStart  = SendMessageA(.Handle,SEM_GETSELSTART,0,0)
           .SelLength = SendMessageA(.Handle,SEM_GETSELLENGTH,0,0)
        End If
    End Property
    
    Property Set SetSelLength(Value As Integer)
        .SelLength = Value
        If .Handle Then
           SendMessage(.Handle,SEM_SETSELLENGTH,Value,0)
        End If
    End Property
    
    Property Set SetSelStart(Value As Integer)
        .SelStart = Value
        If .Handle Then
           SendMessage(.Handle,SEM_SETSELSTART,Value,0)
        End If
    End Property
    
    Property Set SetAllowCompletion(Value As Integer)
        .AllowCompletion = Value
        If .Handle Then
           SendMessage(.Handle,SEM_ALLOWCOMPLETION,Value,0)
        End If
    End Property
    
    Property Set SetWindowCompletionStrings(value As String)
        .WindowCompletionStrings = Value
        If .Handle Then
           DefStr s = .WindowCompletionStrings
           SendMessage(.Handle,SEM_SETTEXTITEMLISTCOMPL,0,VarPTR(s))
        End If
    End Property
    
    Property Set SetWindowCompletionTemplate(value As String)
        .WindowCompletionTemplate = value
        If .Handle Then
           DefStr s = .WindowCompletionTemplate
           SendMessage(.Handle,SEM_SETTEXTINSERTLISTCOMPL,0,VarPTR(s))
        End If
    End Property
    
    Property Set SetHintCompletionStrings(value As String)
        .HintCompletionStrings = value
        If .Handle Then
           DefStr s = .HintCompletionStrings
           SendMessage(.Handle,SEM_SETTEXTITEMLISTCOMPL,1,VarPTR(s))
        End If
    End Property

    Property Set SetHintCompletionTemplate(value As String)
        .HintCompletionTemplate = value
        If .Handle Then
           DefStr s = .HintCompletionTemplate
           SendMessage(.Handle,SEM_SETTEXTINSERTLISTCOMPL,1,VarPTR(s))
        End If
    End Property
    
    Property Set SetSelection.Mode(Value As Integer)
        .Selection.Mode = Value
        If .Handle Then
           If Value < 0 Or Value > 3 Then Value = 0
           SEndMessage(.Handle,SEM_SETSELECTIONMODE,Value,0)
        End If
    End Property
    
    Property Set SetSelection.Background(Value As Integer)
        .Selection.Background = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_SETSELECTIONCOLOr,Value,.Selection.FOreground)
        End If
    End Property
    
    Property Set SetSelection.FOreground(Value As Integer)
        .Selection.FOreground = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_SETSELECTIONCOLOr,.Selection.Background,Value)
        End If
    End Property
    
    Property Set SetBreakLine(Value As Integer)
        Dim LIf As T_SPECIALLINEINFO
        .BreakLine = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSPECIALLINEINFO,0,LIf)
           LIf.BreakLine = .BreakLine
           SEndMessage(.Handle,SEM_SETSPECIALLINEINFO,0,LIf)
        End If
    End Property
    
    Property Set SetMaxUndo(Value As Integer)
        .MaxUndo = Value
        If .Handle Then SendMessage(.Handle,SEM_SETMAXUNDO,Value,0)
    End Property
    
    Property Set SetTabWidth(Value As Integer)
        .TabWidth = Value
        If .Handle Then SendMessage(.Handle,SEM_SETTABWIDTH,Value,0)
    End Property
    
    Property Set SetTabStop(Value As Integer)
        .TabStop = Value
        If .Handle Then SendMessage(.Handle,SEM_SETTABSTOP,Value,0)
    End Property
    
    Property Set SetWantTabs(Value As Integer)
        .WantTabs = Value
        If .Handle Then SendMessage(.Handle,SEM_SETWANTTABS,Value,0)
    End Property
    
    Property Set SetInsertMode(Value As Integer)
        .InsertMode = Value
        If .Handle Then SendMessage(.Handle,SEM_SETINSERTMODE,Value,0)
    End Property
    
    Property Set SetInsertCaret(Value As Integer)
        .InsertCaret = Value
        If .Handle Then SendMessage(.Handle,SEM_SETINSERTCARET,Value,0)
    End Property
    
    Property Set SetOverwriteCaret(Value As Integer)
        .OverwriteCaret = Value
        If .Handle Then SendMessage(.Handle,SEM_SETOVERWRITECARET,Value,0)
    End Property

    Property Set SetHideSelection(Value As Integer)
        .HideSelection = Value
        If .Handle Then SendMessage(.Handle,SEM_SETHIDESELECTION,Value,0)
    End Property
    
    Property Set SetRightEdge(Value As Integer)
        .RightEdge = Value
        If .Handle Then SendMessage(.Handle,SEM_SETRIGHTEDGE,Value,0)
    End Property
    
    Property Set SetRightEdgeColor(Value As Integer)
        .RightEdgeColor = Value
        If .Handle Then SendMessage(.Handle,SEM_SETRIGHTEDGECOLOR,Value,0)
    End Property
    
    Property Set SetScrollBars(Value As Integer)
        .ScrollBars = Value
        If .Handle Then SendMessage(.Handle,SEM_SETSCROLLBARS,Value,0)
    End Property
    
    Property Set SetHint(Value As String)
        .Hint = Value
        DefStr s = Value
        If .Handle Then SendMessage(.Handle,SEM_SETHINT,0,VarPTR(s))
    End Property
    
    Property Set SetShowHint(Value As Integer)
        .ShowHint = Value
        If .Handle Then SendMessage(.Handle,SEM_SETSHOWHINT,Value,0)
    End Property
    
    Property Set SetScrollHintFormat(Value As Integer)
        .ScrollHintFormat = Value
        If .Handle Then SendMessage(.Handle,SEM_SETSCROLLHINTFORMAT,Value,0)
    End Property
    
    Property Set SetScrollHintColor(Value As Integer)
        .ScrollHintColor = Value
        If .Handle Then SendMessage(.Handle,SEM_SETSCROLLHINTCOLOR,Value,0)
    End Property
    
    Property Set SetKeywords.Background(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
           A.Background = Value
           SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
           .KeywOrds.Background  = Value
        End If
    End Property
    
    Property Set SetKeywords.FOreground(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
           A.FOreground = Value
           SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
           .KeywOrds.FOreground  = Value
        End If
    End Property
    
    Property Set SetKeywords.Bold(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
           A.Bold = Value
           SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
           .KeywOrds.Bold  = Value
        End If
    End Property
    
    Property Set SetKeywords.Italic(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
        SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
        A.Italic = Value
        SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
        .KeywOrds.Italic  = Value
        End If
    End Property
    
    Property Set SetKeywords.Underline(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
           A.Underline = Value
           SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
           .KeywOrds.Underline  = Value
        End If
    End Property
    
    Property Set SetKeywords.Strikeout(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETKEYSATTRIBUTES,0,A)
           A.Strikeout = Value
           SEndMessage(.Handle,SEM_SETKEYSATTRIBUTES,0,A)
           .KeywOrds.Strikeout  = Value
        End If
    End Property
    
    Property Set SetSymbols.Background(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
           A.Background = Value
           SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
           .KeywOrds.Background  = Value
        End If
    End Property

    Property Set SetSymbols.FOreground(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
           A.FOreground = Value
           SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
           .KeywOrds.FOreground  = Value
        End If
    End Property

    Property Set SetSymbols.Bold(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
           A.Bold = Value
           SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
           .KeywOrds.Bold  = Value
        End If
    End Property

    Property Set SetSymbols.Italic(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
        SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
        A.Italic = Value
        SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
        .KeywOrds.Italic  = Value
        End If
    End Property

    Property Set SetSymbols.Underline(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
           A.Underline = Value
           SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
           .KeywOrds.Underline  = Value
        End If
    End Property

    Property Set SetSymbols.Strikeout(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSYMBOLATTRIBUTES,0,A)
           A.Strikeout = Value
           SEndMessage(.Handle,SEM_SETSYMBOLATTRIBUTES,0,A)
           .KeywOrds.Strikeout  = Value
        End If
    End Property
    
    Property Set SetNumbers.Background(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
           A.Background = Value
           SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
           .KeywOrds.Background  = Value
        End If
    End Property

    Property Set SetNumbers.FOreground(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
           A.FOreground = Value
           SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
           .KeywOrds.FOreground  = Value
        End If
    End Property

    Property Set SetNumbers.Bold(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
           A.Bold = Value
           SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
           .KeywOrds.Bold  = Value
        End If
    End Property

    Property Set SetNumbers.Italic(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
        SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
        A.Italic = Value
        SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
        .KeywOrds.Italic  = Value
        End If
    End Property

    Property Set SetNumbers.Underline(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
           A.Underline = Value
           SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
           .KeywOrds.Underline  = Value
        End If
    End Property

    Property Set SetNumbers.Strikeout(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETNUMBERATTRIBUTES,0,A)
           A.Strikeout = Value
           SEndMessage(.Handle,SEM_SETNUMBERATTRIBUTES,0,A)
           .KeywOrds.Strikeout  = Value
        End If
    End Property

    Property Set SetComments.Background(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.Background = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.Background  = Value
        End If
    End Property

    Property Set SetComments.FOreground(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.FOreground = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.FOreground  = Value
        End If
    End Property

    Property Set SetComments.Bold(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.Bold = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.Bold  = Value
        End If
    End Property

    Property Set SetComments.Italic(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.Italic = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.Italic  = Value
        End If
    End Property

    Property Set SetComments.Underline(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.Underline = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.Underline  = Value
        End If
    End Property

    Property Set SetComments.Strikeout(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETCOMMENTATTRIBUTES,0,A)
           A.Strikeout = Value
           SEndMessage(.Handle,SEM_SETCOMMENTATTRIBUTES,0,A)
           .Comments.Strikeout  = Value
        End If
    End Property
    
    Property Set SetStrings.Background(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.Background = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
           .Strings.Background  = Value
        End If
    End Property

    Property Set SetStrings.FOreground(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.FOreground = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
           .Strings.FOreground  = Value
        End If
    End Property

    Property Set SetStrings.Bold(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.Bold = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
          .Strings.Bold  = Value
        End If
    End Property

    Property Set SetStrings.Italic(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.Italic = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
           .Strings.Italic  = Value
        End If
    End Property

    Property Set SetStrings.Underline(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.Underline = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
           .Strings.Underline  = Value
        End If
    End Property

    Property Set SetStrings.Strikeout(Value As Integer)
        Dim A As T_ATTRIBUTES
        If .Handle Then
           SEndMessage(.Handle,SEM_GETSTRINGATTRIBUTES,0,A)
           A.Strikeout = Value
           SEndMessage(.Handle,SEM_SETSTRINGATTRIBUTES,0,A)
           .Strings.Strikeout  = Value
        End If
    End Property
    
    Property Set SetGutter.Width(Value As Integer)
        .Gutter.Width = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETGUTTERWIDTH,Value,0)
    End Property
    
    Property Set SetGutter.ColOr(Value As Integer)
        .Gutter.ColOr = Value
        If .Handle Then SEndMessage(.Handle,SEM_SETGUTTERCOLOr,0,Value)
    End Property
    
    Property Set SetGutter.Visible(Value As Integer)
        .Gutter.Visible = Value
        If .Handle Then SEndMessage(.Handle,SEM_SHOWGUTTER,Value,0)
    End Property
    
    Property Set SetGutter.LineNumbers(Value As Integer)
        .Gutter.LineNumbers = Value
        If .Handle Then SEndMessage(.Handle,SEM_SHOWLINENUMBERS,Value,0)
    End Property
    
    Property Set SetGutter.Gradient(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.Gradient = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.Gradient = Value
    End Property
    
    Property Set SetGutter.GradientStep(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.GradientStep = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.GradientStep = Value
    End Property
    
    Property Set SetGutter.StartColOr(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.StartColOr = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.StartColOr = Value
    End Property
    
    Property Set SetGutter.EndColOr(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.EndColOr = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.EndColOr = Value
    End Property
    
    Property Set SetGutter.Font.Name(Value As String)
        Dim GT As T_GUTTER
        DefStr s = Value
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.FontName = VarPTR(s)
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.Font.Name = Value
    End Property
    
    Property Set SetGutter.Font.Size(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.FontSize = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.Font.Size = Value
    End Property
    
    Property Set SetGutter.Font.ColOr(Value As Integer)
        Dim GT As T_GUTTER
        If .Handle Then
           SEndMessage(.Handle,SEM_GETGUTTER,0,GT)
           GT.FontColOr = Value
           SEndMessage(.Handle,SEM_SETGUTTER,0,GT)
        End If
        .Gutter.EndColOr = Value
    End Property
    
    Private:
    
    Sub Initialize
        DefInt F4
        Bind F4 To This.ParentWndProc
        .ParentProc = SetNewCallback_4(F4)
        Bind F4 To This.EditOrWndProc
        .EditOrProc = SetNewCallback_4(F4)
    End Sub
    
    End With
    
    ConstructOr
    Initialize
    Left   = 0
    Top    = 0
    Width  = 221
    Height = 221
    End ConstructOr
End Type
