' Very simple notepad like editor, in less than 200 lines of code!

$APPTYPE   GUI
$TYPECHECK ON              '' Strict type checking, so I don't make mistakes.
$INCLUDE   "RAPIDQ.INC"    '' You don't need them all in this example.

DIM editorForm AS QForm
DIM eDialogBox AS QForm
DIM eEditBox AS QEdit
DIM eRichEdit AS QRichEdit
DIM eMainMenu AS QMainMenu
DIM eFile AS QMenuItem, Edit AS QMenuItem
DIM New AS QMenuItem, Open AS QMenuItem, ReOpen AS QMenuItem
DIM ReOpen1 AS QMenuItem, ReOpen2 AS QMenuItem, ReOpen3 AS QMenuItem
DIM Save AS QMenuItem, SaveAs AS QmenuItem
DIM Break1 AS QMenuItem
DIM ExitEditor AS QMenuItem
DIM Copy AS QMenuItem, Cut AS QMenuItem, Paste AS QMenuItem, SelectAll AS QMenuItem
DIM Search AS QMenuItem, Find AS QMenuItem
DIM FileName AS STRING
    FileName = "UNTiTLED"
DIM CountFiles AS BYTE
    CountFiles = 0
DIM StatusBar AS QStatusBar
    StatusBar.Parent = editorform
    StatusBar.AddPanels "",""
    StatusBar.Panel(0).Width = 100
    StatusBar.Panel(0).Alignment = taCenter

SUB ExitEditorClick    '' Exit item clicked
  editorform.Close
END SUB

SUB NewClick           '' New item clicked
  eRichEdit.Clear
  FileName = "UNTiTLED"
END SUB

SUB OpenClick          '' Open item clicked
  DIM OpenDialog AS QOpenDialog

  IF OpenDialog.Execute THEN
    FileName = OpenDialog.FileName
    eRichEdit.LoadFromFile FileName
    IF CountFiles = 0 THEN
      ReOpen.Enabled = True
      ReOpen1.Caption = "&1. "+FileName
      ReOpen.Insert 0, ReOpen1
    ELSEIF CountFiles = 1 THEN
      ReOpen2.Caption = "&2. "+FileName
      ReOpen.Insert 1, ReOpen2
    ELSEIF CountFiles = 2 THEN
      ReOpen3.Caption = "&3. "+FileName
      ReOpen.Insert 2, ReOpen3
    ELSE
      CountFiles = CountFiles - 1
      ReOpen1.Caption = "&1. "+RIGHT$(ReOpen2.Caption, LEN(ReOpen2.Caption)-4)
      ReOpen2.Caption = "&2. "+RIGHT$(ReOpen3.Caption, LEN(ReOpen3.Caption)-4)
      ReOpen3.Caption = "&3. "+FileName
    END IF
    CountFiles = CountFiles + 1
    eRichEdit.Modified = False
  END IF
END SUB

SUB SaveAsClick          '' SaveAs item clicked
  DIM SaveDialog AS QSaveDialog

  IF SaveDialog.Execute THEN
    eRichEdit.SaveToFile SaveDialog.FileName
  END IF
END SUB

SUB SaveClick
  IF FileName = "UNTiTLED" THEN
    SaveAsClick
  ELSE
    eRichEdit.SaveToFile FileName
  END IF
END SUB

SUB CopyClick:  eRichEdit.CopyToClipBoard:    END SUB   '' Oh yeah, that was easy
SUB CutClick:   eRichEdit.CutToClipBoard:     END SUB
SUB PasteClick: eRichEdit.PasteFromClipBoard: END SUB
SUB SelectAllClick: eRichEdit.SelectAll:      END SUB

SUB Reopen1Click
  IF eRichEdit.Modified THEN
    SHOWMESSAGE "Abandoning changes"
  END IF
  eRichEdit.LoadFromFile RIGHT$(ReOpen1.Caption, LEN(ReOpen1.Caption)-4)
  eRichEdit.Modified = False
END SUB

SUB Reopen2Click
  IF eRichEdit.Modified THEN
    SHOWMESSAGE "Abandoning changes"
  END IF
  eRichEdit.LoadFromFile RIGHT$(ReOpen2.Caption, LEN(ReOpen2.Caption)-4)
  eRichEdit.Modified = False
END SUB

SUB Reopen3Click
  IF eRichEdit.Modified THEN
    SHOWMESSAGE "Abandoning changes"
  END IF
  eRichEdit.LoadFromFile RIGHT$(ReOpen3.Caption, LEN(ReOpen3.Caption)-4)
  eRichEdit.Modified = False
END SUB

SUB FindText   '' Primitive search...
  eRichEdit.SelStart = INSTR(UCASE$(eRichEdit.Text), UCASE$(eEditBox.Text))-1
  IF eRichEdit.SelStart > 0 THEN
    DIM Font AS QFont
        Font.AddStyles(fsBold, fsItalic)

    eRichEdit.SelLength = LEN(eEditBox.Text)
    eRichEdit.SelAttributes = Font
    eDialogBox.Close
  ELSE
    SHOWMESSAGE eEditBox.Text+" not found."
  END IF
END SUB

SUB FindClick
  DIM Button AS QButton

  Button.Parent = eDialogBox
  Button.OnClick = FindText
  Button.Caption = "&OK"
  Button.Top = 13
  Button.Left = 210
  Button.Width = 70

  eEditBox.Parent = eDialogBox
  eEditBox.Top = 15
  eEditBox.Left = 20
  eEditBox.Width = 170

  eDialogBox.BorderStyle = bsDialog
  eDialogBox.Caption = "Search..."
  eDialogBox.Width = 300
  eDialogBox.Height = 80
  eDialogBox.Center

  eDialogBox.ShowModal
END SUB

SUB FormResize
  eRichEdit.Width = editorform.ClientWidth
  eRichEdit.Height = editorform.ClientHeight
END SUB

SUB RichShowXY
  StatusBar.Panel(0).Caption = STR$(eRichEdit.WhereY+1)+" : "+STR$(eRichEdit.WhereX+1)
END SUB

New.Caption = "&New"           : New.OnClick = NewClick
Open.Caption = "&Open"         : Open.OnClick = OpenClick
ReOpen.Caption = "&ReOpen"
ReOpen.Enabled = False
ReOpen1.Caption = ""           : ReOpen1.OnClick = Reopen1Click
ReOpen2.Caption = ""           : ReOpen2.OnClick = Reopen2Click
ReOpen3.Caption = ""           : ReOpen3.OnClick = Reopen3Click
Save.Caption = "&Save"         : Save.OnClick = SaveClick
SaveAs.Caption = "Save &As..." : SaveAs.OnClick = SaveAsClick
Break1.Caption ="-"
ExitEditor.Caption = "E&xit"   : ExitEditor.OnClick = ExitEditorClick

eFile.Caption = "&File"
eFile.AddItems New,Open,ReOpen,Save,SaveAs,Break1,ExitEditor

Copy.Caption = "&Copy"   : Copy.OnClick = CopyClick
Copy.ShortCut = "CTRL+C"
Cut.Caption  = "Cu&t"   : Cut.OnClick = CutClick
Cut.ShortCut = "CTRL+X"
Paste.Caption = "&Paste" : Paste.OnClick = PasteClick
Paste.ShortCut = "CTRL+V"
SelectAll.Caption = "&Select All" : SelectAll.OnClick = SelectAllClick

Edit.Caption = "&Edit"
Edit.AddItems Copy,Cut,Paste,SelectAll

Find.Caption = "&Find"
Find.OnClick = FindClick

Search.Caption = "&Search"
Search.AddItems Find

eMainMenu.Parent = editorform
eMainMenu.AddItems eFile,Edit,Search

eRichEdit.Parent = editorform
eRichEdit.Align = alClient
'eRichEdit.Width = editorform.ClientWidth
'eRichEdit.Height = editorform.ClientHeight
eRichEdit.ScrollBars = ssBoth
eRichEdit.PlainText = True
eRichEdit.WordWrap = False
eRichEdit.OnKeyUp = RichShowXY
eRichEdit.OnMouseMove = RichShowXY

editorform.Caption = "Simple, notepad like editor"
editorform.Width = 500
editorform.Height = 400
editorform.Center
editorform.OnResize = FormResize
editorform.ShowModal
